/* Enums.h                                        */
/* Achtung: Spter aus ExprInterface.h bernehmen */
/* Tobias Himstedt 1995                           */
/* Burkhard Bieber 1995/96                        */
/* last-update: 09.04.96                          */

#ifndef __ENUMS_H__
#define __ENUMS_H__

#undef False
#undef True
#ifndef __cplusplus
typedef enum { False = 0, True } bool;
#else
#define False false
#define True true
#endif

  /*********/
  /* Typen */
  /*********/

#ifdef BOOLEAN
#undef BOOLEAN
#endif
enum ValueType {INTEGER, BOOLEAN, DOT, TUPEL, STRING};
enum DotType {dot};
enum NodeType {VARIABLE, VALUE , OPERATOR};
typedef enum {
  ADD, SUB, MULT, DIV, LE, GT, LE_EQ, GT_EQ, EQ, 
  NOT_EQ, AND, OR, IMP, MOD, NOT, PR0, PR1 
} OperatorType;

#endif  /* #ifndef __ENUMS_H__ */

  /*** Dateiende Enums.h ***/

