/* ExprInterface.h                                               */
/* Achtung: Diese Datei wird vom C-Compiler und vom C++-Compiler */
/*          bearbeitet. Die Kommentare sollten also nach den     */
/*          C-Regeln fr die Syntax gestaltet sein.              */
/* Tobias Himstedt 1995                                          */
/* Burkhard Bieber 1995                                          */
/* last-update: 23.09.95                                         */

#ifndef __EXPRINTERFACE_H__
#define __EXPRINTERFACE_H__

  /************/
  /* includes */
  /************/

#include "Enums.h"

  /**************/
  /* Prototypen */
  /**************/

#ifdef __cplusplus
  extern "C" {
#endif

void new_ident(char *s);
void new_number(int a);
void new_number_dot(void);
void new_number_bool(bool t);
void new_operator(OperatorType t);
void new_value(int);
void new_value_bool(bool);
void new_value_dot(void);
void new_values(int, int);
void new_quantor(char*);
void store_last(void);
void make_cross(void);

#ifdef __cplusplus
  }  /* extern "C" */
#endif

#endif

  /*** Dateiende ExprInterface.h ***/

