#ifndef __REF_H__
#define __REF_H__

enum {	REF_SYSTEM, REF_BLOCK,
	REF_CHANNEL, REF_SIGNALROUTE, REF_SIGNAL, REF_CONNECT,
	REF_SYNTYPE, REF_VARIABLE,
	REF_IN_PARM, REF_IN_OUT_PARM,
	REF_PROCESS, REF_PROCEDURE,
	REF_ACTION, REF_ANSWER, REF_LABEL,
	REF_TRIGGER
     };
	
#define REF_TYPE_CHARS		\
     {  'K', 'E',		\
	'C', 'R', 'S', 'X',	\
	' ', 'V',		\
	'I', 'O',		\
	'P', 'U',		\
	'A', 'W', 'L',		\
	'T',			\
	'\0'			\
     };

typedef struct
{
	char type;
	int nr;
	int start_l, start_c;
	int end_l, end_c;
	void *ptr;
	int proc;
} *T_ref, ref_instance;

#define alloc_ref() (MYmalloc(sizeof(ref_instance)))

extern void init_references();
extern void make_ref(T_ref,int,int,int);
extern T_ref add_ref(void*,char,T_ref,T_ref);

#endif /* __REF_H__ */
