#!/bin/sh

SRC="[^m]*.ll_net *.petri_box"
SRC2="m*.ll_net"
DEST="*.form.ft"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i;
  $TIME ../TransForm $i -i=$i.form;
done
for i in ${SRC2}; do
  echo Checking $i;
  $TIME ../TransForm $i -s=$i.sdl_ll_ref -i=$i.form;
done

#check correctness
for i in ${DEST}; do
  if `diff $i $i.correct >/dev/null`; then
    rm $i;
    echo File $i passed ...;
  else
    echo File $i failed ...;
    echo `pwd`/$i >>$LOG;
  fi
done
