#ifndef __NETS_H__
#define __NETS_H__

#include "global.h"

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

Place insert_condition( LMPNet unfold_net, Place pl_org,
			BIT_ARRAY conflArrayPtr );

#else

Place insert_condition( unfold_net, pl_org, conflArrayPtr );

#endif

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

Event insert_event( LMPNet unfold_net, Transition tr_org );

#else

Event insert_event( unfold_net, tr_org );

#endif

#define insert_tic(unfold_net) insert_event(unfold_net, NULL);

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void insert_ec_edge( Event event, Condition condition );

#else

void insert_ec_edge( event, condition );

#endif

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void insert_postset_list( LIST list, LMPNet unfold_net );

#else

void insert_postset_list( list, unfold_net );

#endif

#endif /* __NETS_H__ */
