/**********************************/
/* main.h                         */
/* Burkhard Graves, 10.10.93      */
/* Lars Jenner, Juni 1994         */
/* Burkhard Graves, 24.02.95      */
/**********************************/

#ifndef __MAIN_H__
#define __MAIN_H__

/*********************/
/* Prototypen an/aus */
/*********************/

#if 1
#define PROTO(x) x
#else
#define PROTO(x) ()
#endif

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include "../frontend/function.h"
 
/**********************************/
/* Globale Defines                */
/**********************************/

#define _FALSE   -32766 /* INT_MIN+2 */
#define _TRUE    -32765 /* INT_MIN+3 */
#define _NO_INIT -32764 /* INT_MIN+4 */
#define _LIMIT   -32764 /* INT_MIN+4 */

/**********************************/
/* Globale Datenstrukturen        */
/**********************************/

extern FILE *yyin,*yyout;
extern int dinit,rec_depth,max_rec_depth;

/**********************************/
/* Globale Funktionen             */
/**********************************/

void        Msg PROTO ((int type,...));
void  *MYmalloc PROTO ((size_t size));
void *MYrealloc PROTO ((void *ptr, size_t size));
char  *MYstrdup PROTO ((char *str));

#endif

/**********************************/
/* END OF FILE main.h             */
/**********************************/
