/**********************************/
/* range.h                        */
/* Burkhard Graves, 14.07.95      */
/**********************************/

#ifndef __RANGE_H__
#define __RANGE_H__

#include "main.h"

#define is_bool(x) (x<=_TRUE)
#define is_not_bool(x) (x>_TRUE)

/**********************************/
/* Globale Typdefinitionen        */
/**********************************/

typedef struct _range {
    struct _range *next;
    int            von,bis;
} Range;

/**********************************/
/* Globale Funktionen             */
/**********************************/
 
Range       *GenRange PROTO ((int von,int bis));
Range    *insert_elem PROTO ((Range *insert,Range *head));
Range *RangeDuplicate PROTO ((Range *range));
void       delete_set PROTO ((Range *range));
char      *WriteRange PROTO ((char *buffer,Range *range)); 
void     DisplayRange PROTO ((FILE *file,Range *range)); 
int        IsSubRange PROTO ((Range *sub_range,Range *range));
int         IsInRange PROTO ((Range *range,int elem));
Range  *RangeCompress PROTO ((Range *range));

#endif

/**********************************/
/* END OF FILE range.h            */
/**********************************/
