/******************************************************************************/
/* iter.h                                                                     */
/* Burkhard Graves, 17.12.93                                                  */
/* Martin Ackermann, Fruehjahr 95                                             */
/* (modifiziert fuer M-Netze, enter-Netz eingefuehrt)                         */
/* Burkhard Bieber 1995:                                                      */
/*   - Schoenheitskorrekturen                                                 */
/* Martin Ackermann, Winter 1996/97                                           */
/*   - Prozeduren, andere Referenzen, mehr Effizienz, Fehler beseitigt        */
/******************************************************************************/

#ifndef __ITER_H__
#define __ITER_H__

  /* Das Netz enter wird beim Betreten des Loops einmalig ausgefuehrt. */
  /* Die Reference repeat-ref wird bei einem Small-Loop an die         */
  /* TRUE-Transition geschrieben, die das REPEAT realisiert.           */

M_Net SmallIteration(alt_set_type alt, M_Net enter);
M_Net BigIteration(alt_set_type alt, M_Net enter);
M_Net MediumIteration(alt_set_type alt, M_Net enter);

#endif  /* #ifndef __ITER_H__ */

/**********************/
/* END OF FILE iter.h */
/**********************/

