/******************************************************************************/
/* move.h                                                                     */
/* Burkhard Graves, 20.12.93                                                  */
/* Martin Ackermann, Fruehjahr 95                                             */
/* (lediglich Umbenennung der Variablen- & Funktionsnamen auf M-Netze)        */
/* Martin Ackermann, Winter 1996/97                                           */
/*   - Prozeduren, andere Referenzen, mehr Effizienz, Fehler beseitigt        */
/******************************************************************************/

#ifndef __MOVE_H__
#define __MOVE_H__

#include "mnet.h"

void       M_juxtapose(M_Net net1,M_Net net2);
M_Net       M_move_hor(M_Net net,int x_offset);
M_Net       M_move_ver(M_Net net,int y_offset);
M_Net        M_move_hv(M_Net net,int x_offset,int y_offset);
M_Net      M_turn_left(M_Net net);
M_Net     M_turn_right(M_Net net);
M_Net    M_up_and_down(M_Net net,int y1,int y2,int offset);
M_Net M_left_and_right(M_Net net,int x1,int x2,int offset);
M_Net        M_explode(M_Net net,int y1,int y2,
                                 int x1,int x2,
                                 int y_offset,int x_offset);

#endif

/**********************/
/* END OF FILE move.h */
/**********************/
