/******************************************************************************/
/* FILE set.h                                                                 */
/* Stephan Merkel, May 95                                                     */
/* Martin Ackermann, Winter 1996/97                                           */
/******************************************************************************/

#ifndef __SET_H__
#define __SET_H__

#include "boxtypes.h"


/******************************************************************************/
/* SetRange                                                                   */
/******************************************************************************/

typedef struct _range {
    struct _range *next;
    Cardinal       von,bis;
} Range;


/******************************************************************************/
/* Globale Funktionen                                                         */
/******************************************************************************/

Range *GenRange(Cardinal von,Cardinal bis);
Range *GenRangeList(Range *list,Range *range);
void KillRange(Range *range);


#endif /* __SET_H__ */

/******************************************************************************/
/* END OF FILE set.h                                                          */
/******************************************************************************/
