#ifndef LIST_H
#define LIST_H
/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : list.h                                        
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/

#include <stdlib.h>
#include <string.h>
#include "configure.h"
#include "symboltable.h"

/* Linear chaining list type */

typedef struct listzeiger {
  char identifier[MAX_IDENT_LENGTH];
  int  partype;
  int  bucket;
  struct listzeiger* next;
} list;


list* empty_list(void);
list* append_list(list* ident_list, char ident[], int ptype);
list* get_ident(list* ident_list, char* ident, int* par_type);


#endif /* LIST_H */

/*-------------------------------------------------------------------------*/
/* End of file list.h */
/*-------------------------------------------------------------------------*/
