#ifndef LOCAL_SEM_H
#define LOCAL_SEM_H
/*-------------------------------------------------------------------------*/
/*  local_sem.h                                                            */
/*-------------------------------------------------------------------------*/
/*  B(PN)^2 -> C Codegenerator                                              */
/*                                                                         */
/*  Johannes Jaeger --- Sommer 1997                                        */
/*-------------------------------------------------------------------------*/


/* aktuell benoetigte Anzahl an Semaphoren    */
/* bei Aenderungen Anpassungen in local_sem.c */
/* (z.B. struct op_op[]) nicht vergessen      */
#define NUM_SEMS     4

/* Nummern der Semaphore */
#define TABLE_NUM    0
#define SYNCHRO_NUM  1
#define SEMPROT_NUM  2
#define FUNCCALL_NUM 3

void sem_create(void);
void sem_wait(int sem_num);
void sem_signal(int sem_num);
void sem_delete(void);

/*-------------------------------------------------------------------------*/
/* End of file local_sem.h */
/*-------------------------------------------------------------------------*/
#endif /* LOCAL_SEM_H */
