/**********************************/
/* ops.h                          */
/* Burkhard Graves, 06.10.93      */
/**********************************/

#ifndef __OPS_H__
#define __OPS_H__

#include "../frontend/function.h"


/**********************************/
/* Globale Defines                */
/**********************************/

#define transl(x)      ( (x==TT) ? 1 : ((x==FF) ? 0 : x) )

/**********************************/
/* Globale Funktionen             */
/**********************************/

int             or PROTO ((int wert1,int wert2));
int            and PROTO ((int wert1,int wert2));
int            not PROTO ((int wert));
int          equal PROTO ((int wert1,int wert2));
int         nequal PROTO ((int wert1,int wert2));
int          lower PROTO ((int wert1,int wert2));
int        greater PROTO ((int wert1,int wert2));
int         gequal PROTO ((int wert1,int wert2));
int         lequal PROTO ((int wert1,int wert2));
int           plus PROTO ((int wert1,int wert2));
int          minus PROTO ((int wert1,int wert2));
int multiplication PROTO ((int wert1,int wert2));
int       division PROTO ((int wert1,int wert2));
int         modulo PROTO ((int wert1,int wert2));
int         negate PROTO ((int wert));

/**********************************/
/* END OF FILE ops.h              */
/**********************************/

#endif /* __OPS_H__ */
