#!/bin/sh

SRC="*.ll_net"
DEST="*.fc2"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i;
  $TIME ../inria5pep $i;
done

#check correctness
for i in ${DEST}; do
  if `diff $i $i.correct >/dev/null`; then
    rm $i;
    echo File $i passed ...;
  else
    echo File $i failed ...;
    echo `pwd`/$i >>$LOG;
  fi
done
