#include <stdlib.h>
#include "global.h"
extern int counter, tokenvalue;
int main()
{
  int token;
  while ((token=yylex())) {
    switch (token) {
      case NONE       : printf("\n %c not classifiable\n",tokenvalue); break;
      case AUSSAGE    : printf("p%d",counter); ++counter; break;
      case AND        : printf("&&"); break;
      case NOT        : printf("!"); break;
      case OR         : printf("||"); break;
      case IMPLI      : printf("->"); break;
      case EQUIV      : printf("<->"); break;
      /* BG: this line will become relevant if spin -F filename works */
      /* case ALWAYS     : printf("[]"); break; */
      case ALWAYS     : printf("\\[\\]"); break;
      case EVENTU     : printf("<>"); break;
      case UNTIL      : printf("U"); break;
      case CONTRA     : printf("V"); break;
      case OPEN       : printf("("); break;
      case CLOSE      : printf(")"); break;
    }
  }
printf("\n");
exit(0);
}
