/********************************************************************/
/* Modelchecker							    */
/* Datei		:  mca.c				    */
/* Autor		:  Thomas Thielke			    */
/* letzte Aktualisierung:  09.03.1994				    */
/********************************************************************/

/* Includes							*/
#include <stdio.h>
#include <string.h>

#include "mca.h"
#include "mca1.h"
#include "error.h"

char ** plnamen, ** trnamen;
int _np, _nt;

  int    DEB=0;
		     
int main(int argc, char **argv)

{
  char *net_file; /* Name der Netzdatei			*/
  char *formula_file; /* Name der Formeldatei		*/
  FILE* fp_out; /* Result file descriptor. */

/* Ein-/Ausgabesteuerung 					*/

	if (argc < 3)  {mca_error(ERR9); exit(9); }
	else if (argc > 4)  {mca_error(ERR10); exit(10); }
	else
	{ 
		net_file=strdup(argv[1]);
		formula_file=strdup(argv[2]);
	}

  if (argc == 3)
    fp_out=stdout; 
  else
    fp_out = fopen( argv[3],"w");
  if(!fp_out) {mca_error(ERR5); exit(5);}
 

/* Modelchecker aufrufen					*/

 mca1(net_file,formula_file,fp_out);
 exit(0);

}/*ENDMCA*/

