/**************************************************************************/
/* MOBY2inf.c                                                             */
/* Konverter: erzeugt aus MOBY-Dateien entsprechende Dateien im           */
/*            inf-Dateiformat.                                            */
/**************************************************************************/
/* Di., 01.02.1994                                          Stefan Roemer */
/**************************************************************************/

#include "neunetze.h"
#include "rw_inf.h"

int main( int argc, char **argv )
  {

    LMPNet net; 

    if ( argc != 3 )
      {
        printf( "Aufruf: %s <Eingabedatei> <Ausgabedatei> !\n", *argv );
        exit ( 1 );
      } /* if */

    net = praktikum_ini( argv[1] );
    write_matrix( net, argv[2] );
    write_netmarking( net, argv[2] );
    
    remove_net( &net );

    exit ( 0 );

} /* main() */


/**************************************************************************/
/* END OF FILE MOBY2inf.c                                                 */
/**************************************************************************/

