/* pep_cons.h */
/* Ez a file tartalmazza a pep2tex program 
	konstansait. */

#ifndef PEP_CONS
 #define PEP_CONS

#define MAXLINE 200 	// Beolvasott sor maximalis hossza
#define MAXSTRING 30  	// Stringek maximalis hossza

#define PAGEHEIGHT 670  // Egy allo A4-es oldal magassaga keppontokban
#define PAGEWIDTH 500   // Egy allo A4-es oldal szelessege keppontokban

#define MAXFONTTYPE 3   // Egy abran elofordulo kulonbozo meretu fontok
			// maximalis szama (jelentesek, nevek, egyeb szoveg)

#define MAXLIST   10    // Block- es transition listak maximalis hossza

#define BLOCKSIZE 45	// Blokkok oldalhossza (Pep egyseg)
#define PLACESIZE 21	// Allapot korok atmeroje
#define TRANSSIZE 20	// Allapotatmenet negyzetek oldalhossza
#define TOKENSIZE  7    // Token atmeroje

#define TEXTHEIGHT 18   //  TX reszben  adott szoveg karaktereinek magassaga
#define TEXTWIDTH  10   //  TX reszben  adott szoveg karaktereinek atlagos
			//	szelessege
#define NAMEHEIGHT 10   //  Blokk, allapot, allapotatmenet nevek karaktereinek
			//	 magassaga
#define NAMEWIDTH   7   // Blokk, allapot, allapotatmenet nevek karaktereinek
			//	atlagos szelessege
#define MEANHEIGHT  8   // Blokk, allapot, allapotatmenet jelentesek
			//	karaktereinek magassaga
#define MEANWIDTH   7   // Blokk, allapot, allapotatmenet jelentesek
			//	karaktereinek atlagos szelessege

#define MAXTOKEN    5   // Maximalisan kirajzolt tokenek szama
			//	(Ha ennel tobb, akkor csak a szamuk kerul kiirasra)

#define MAXCHILD    10  // A blokkfa maximalis elagazasainak szama
#define MAXBLOCK    30 // a blokkok maximalis szama

#define WBLOCKSIDE 30 // a blokkok merete a WIndows-os megjeleniteshez

#define PI  3.141592654

#endif

