/* pep_def.h */
/* Ez a file tartalmazza a pep2tex program altalanos tipus
	definicioit. */


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "pep_cons.h"

#ifndef PEP_DEF
	#define PEP_DEF

	#define max(a,b) ((a) > (b) ? (a) : (b))
	#define min(a,b) ((a) < (b) ? (a) : (b))

 //enum {FALSE, TRUE} ;	// Logikai tipus

typedef enum {PhBL, PhPL,PhTR, PhPTR, PhTP, PhPT, PhPTP, PhPPT, PhTX} tphase;
					// Beolvasasi fazisok
typedef enum {BL, PL, TR, PTR} boxtypes;
						 // Box tipusok
typedef struct  {
			 int   x,y;
		  } ticoord, *pticoord;		// Egesz  koordinata tipus (PEP)

typedef struct   {
			 double   x,y;
		  } tfcoord, *ptfcoord;		//Lebegopontos koordinata tipus (Latex)


typedef char string[MAXSTRING];	// String tipus
typedef char tline[MAXLINE]; //Karaktersor tipus

typedef int fontind[MAXFONTTYPE]; // a fontok indexeit tarolo vektor
typedef int boxlist[MAXLIST];    // a block- es transition listakat tarolo vektor

void GetICoord(pticoord Coord, int *X, int *Y);     //Egesz koordinata tipus
							 //lekerdezo muvelete
void SetICoord(pticoord Coord, int X, int Y);       //Egesz koordinata tipus
							 // ertekado muvelete

void GetFCoord(ptfcoord Coord, double *X, double *Y); //Lebegopontos koordinata
								// tipus lekerdezo muvelete
void SetFCoord(ptfcoord Coord, double X, double Y);   //Lebegopontos koordinata
								// tipus ertekado muvelete
const double Factors[] = {0.707, 0.866, 1.00, 1.118, 1.414};
					// A  nagyitas faktorai

const string FontSizes[] = {
				  "tiny",
				  "scriptsize",
				  "footnotesize",
				  "small",
				  "normalsize",
				  "large",
				  "Large",
				  "LARGE",
			  };

#define boolean int
#define FALSE 0
#define TRUE 1
#endif



