#include "cell.h"

#define CLASS "Cell"

Cell::Cell()
{
  v_index=-1;
  plusinnr=changed=0;
}

Cell::Cell(int _id, StructArray _SA, int _plusinnr, int _changed)
{
  v_index=_id;
  StructA.Copy(_SA);
  plusinnr=_plusinnr;
  changed=_changed;
}

Cell::Cell(int _id, Struct _S, int _plusinnr, int _changed)
{
  v_index=_id;
  StructA.Add(_S);
  plusinnr=_plusinnr;
  changed=_changed;
}

Cell::Cell(const Cell& c)
{
  v_index=c.v_index;
  plusinnr=c.plusinnr;
  changed=c.changed;
  StructA.Copy(c.StructA);
}

Cell& Cell::operator=(const Cell& c)
{
  v_index=c.v_index;
  plusinnr=c.plusinnr;
  changed=c.changed;
  StructA.Copy(c.StructA);
  return *this;
}

