#ifndef CIRCLE_H
#define CIRCLE_H

#include "queue.h"
#include "array.h"

class Circle
{
  public:
    int v_index;          // Index auf die Knoten-Tabelle
    IntArray history;
    Circle();
    Circle(int _id, IntArray _history);
    Circle(const Circle& c);
    ~Circle() {}
    Circle& operator =(const Circle& c);
};

typedef Queue<Circle> QueueCircle;

#endif
 
