
#include "pfa.h"
#include "project.h"
#include <string.h>

char *refname = NULL; 
char *bpnname = NULL;
int main(int argc, char **argv)
{
  int i;
  int StructFlag=1;
  int Loaded=0;
  if (argc<3)
  {
    printf("Usage : %s pfa_project bpn2 [-r reffile] [-n]\n-n unstructured compilation\n-r reference file\n", argv[0]);
    return 0;
  }
  Project prj;
  for (i = 1; i<argc; i++)
  {
    if ((argv[i][0]=='-') && (argv[i][1]=='n'))
      StructFlag=0;
    else
      if ((argv[i][0]=='-') && (argv[i][1]=='r'))
      {
	i++;
	refname=argv[i];
      }
      else
      {
	if (!Loaded)
	{
	  prj.Load(argv[i]);
	  Loaded=1;
	}
	else
	{
	  bpnname=argv[i];
	}
      }
  }
  if (!bpnname)
  {
    printf("Usage : %s pfa_project bpn2 [-r reffile] [-n]\n-n unstructured compilation\n-r reference file\n", argv[0]);
    return 0;
  }
  if (StructFlag)
  {
    prj.CompileBPN2Struct(bpnname);
  }
  else
  {
    prj.CompileBPN2(bpnname);
  }
  return 0;
}
