#!/bin/sh

SRC="*.prj"
DEST="*.bpn2 *_ref"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i;
  $TIME ../pfa2bpn $i `basename $i .prj`.bpn2 -r `basename $i .prj`.bpn2_pfa_ref;
done

#check correctness
for i in ${DEST}; do
  if `diff $i $i.correct >/dev/null`; then
    rm $i;
    echo File $i passed ...;
  else
    echo File $i failed ...;
    echo `pwd`/$i >>$LOG;
  fi
done
