#include "main.h"
#include "compose.h"

Cardinal min_local_blk = 1;

/******************************************************************************/
/* Uebersetzen der Menge set_org von der Darstellung des Frontends in die in- */
/* terne Darstellung des Backends. Die Menge set_new wird zurueckgeliefert.   */
/******************************************************************************/

Integer* Set_Parser2Intern(Set set_org)
{
	Integer *set_new;
  
	set_org = set_org->next;

	set_new = MYmalloc(sizeof(Integer));
	*set_new = 1;
  
	while (set_org)
	{
		add_values(&set_new,set_org->low,set_org->high,True,0,NULL);
		set_org = set_org->next;
	}

	return set_new;
}

static Cardinal id_counter = 1;

Integer* GenerateIdSet(Cardinal n)
{
	Integer *set = MYmalloc((n+1)*sizeof(Integer));
	Cardinal i;

	/* BG nur zum Testen, ob es ausreicht, um nicht-disjunkte
	   id-sets zu bekommen */
	if (flag & NO_DISJUNCT_IDSETS) id_counter=1;

	for (i=1; i<=n; i++) set[i] = id_counter++;
	*set = n+1;

	return set;
}

