#ifndef __INTSET_H__
#define __INTSET_H__

#include <string.h>
#include "memlib.h"
#include "function.h"

typedef Integer *intset;
extern intset alloc_intset();
extern void intset_add(intset*,Integer);
extern void intset_add_interval(intset*,Integer,Integer);
extern void intset_union(intset*,intset);
extern void intset_subtract(intset*,intset);
extern void intset_print(intset);
extern bool    intset_isin(intset,Integer);
extern bool    intset_issubset(intset,intset);

#define intset_isempty(x) (*(x) != 1)
#define intset_length(x) (*(x)-1)
#define intset_elem(x,i) ((x)[i])	/* Index startet mit 1 */
#define intset_equal(x,y) (!memcmp(x,y,*(x)*sizeof(Integer)))
#define for_intset(set,x) for ((x) = (set)+1; (x) < (set)+*(set); (x)++)

#endif /* __INTSET_H__ */
