#!/bin/sh

SRC="*.sdl"
DEST="*.correct"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i;
  $TIME ../s2m $i
done

#check correctness
for i in ${DEST}; do
  declare j=`basename $i .correct`
  if `diff $i $j >/dev/null`; then
    rm $j;
    echo File $j passed...
  else
    echo File $j failed...
    echo `pwd`/$j >>$LOG;
  fi
done
