#include <stdio.h>
#include <time.h>
#include "timer.h"
#include "function.h"

clock_t timer[NUM_TIMERS];
clock_t stop[NUM_TIMERS];
char*	name[NUM_TIMERS];

void init_timers()
{
	int i;
	for (i = 0; i < NUM_TIMERS; i++) timer[i] = 0;
	for (i = 0; i < NUM_TIMERS; i++) name[i] = NULL;
}

void name_timer(int num, char *string)
{
	if (name[num] && strcmp(name[num],string))
		Msg(WAR,"timer %u doubly used",num);
	name[num] = string;
}

void start_timer(int num)
{
	stop[num] = clock();
}

void end_timer(int num)
{
	timer[num] += clock()-stop[num];
}

void print_timers()
{
	int i;
	for (i = 0; i < NUM_TIMERS; i++) if (name[i])
		printf("timer %d: %f (%s)\n",i,
			(float)timer[i]/CLOCKS_PER_SEC,name[i]);
}
