#ifndef __TIMER_H__
#define __TIMER_H__

#include <time.h>

enum {
	TIMER_0, TIMER_1, TIMER_2, TIMER_3,
	TIMER_4, TIMER_5, TIMER_6, TIMER_7,
	NUM_TIMERS
     };

extern clock_t timer[];

extern void init_timers();
extern void name_timer(int,char*);
extern void start_timer(int);
extern void end_timer(int);
extern void print_timers();

#define use_timer(timer,name,x)			\
	{					\
		name_timer(timer,name);		\
		start_timer(timer);		\
		x				\
		end_timer(timer);		\
	}

#endif /* __TIMER_H__ */
