
#include "ChanComp.h"
#include "Helper.h"


//*******************************************************************************************************
olSDL::ClsChanComp::ClsChanComp(e_CompType CompType, const string content, const ClsRecPaS & PaS) : ClsRecPaS(PaS) {
	m_CompType = CompType ;
	m_content = content ;
} ;
//*******************************************************************************************************
olSDL::ClsChanComp::~ClsChanComp() {

	#ifdef olSDL_DL_ONE
	// DebugPrinter::print("DEST:    olSDL::ClsChanComp::~ClsChanComp()") ;
	#endif
} ;
//*******************************************************************************************************
olSDL::ClsChanComp::e_CompType olSDL::ClsChanComp::get_CompType() const {
	return m_CompType ;
} ;
//*******************************************************************************************************
string olSDL::ClsChanComp::get_content( ) const {
	return m_content ;
} ;
//*******************************************************************************************************
void olSDL::ClsChanComp::set_content(const string content) {
	m_content = content ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************

olSDL::ClsChanName::ClsChanName(const string content, const ClsRecPaS & PaS) : ClsChanComp(ClsChanComp::name,content,PaS) {

} ;
//*******************************************************************************************************
olSDL::ClsChanSourceSigList::ClsChanSourceSigList(const string content, const ClsRecPaS & PaS) : ClsChanComp(ClsChanComp::source_sig,content,PaS) {

} ;
//*******************************************************************************************************
olSDL::ClsChanDestSigList::ClsChanDestSigList(const string content, const ClsRecPaS & PaS) : ClsChanComp(ClsChanComp::dest_sig,content,PaS) {

} ;
//*******************************************************************************************************
olSDL::ClsChanSourceCon::ClsChanSourceCon(const string content, const ClsRecPaS & PaS) : ClsChanComp(ClsChanComp::source_con,content,PaS) {

} ;
//*******************************************************************************************************
olSDL::ClsChanDestCon::ClsChanDestCon(const string content, const ClsRecPaS & PaS) : ClsChanComp(ClsChanComp::dest_con,content,PaS) {

} ;
//*******************************************************************************************************

