using namespace std;

#include "RenumberingHelper.h"


//*******************************************************************************************************
olSDL::ClsRenumberingHelper_ErrorReporter::ClsRenumberingHelper_ErrorReporter() {

	m_ErrorType = not_specified ;
} ;
//*******************************************************************************************************
olSDL::ClsRenumberingHelper_ErrorReporter::ClsRenumberingHelper_ErrorReporter(e_ErrorType ErrorType) {

	m_ErrorType = ErrorType ;
} ;
//*******************************************************************************************************
olSDL::ClsRenumberingHelper_ErrorReporter::e_ErrorType olSDL::ClsRenumberingHelper_ErrorReporter::get_ErrorType() const {

	return m_ErrorType ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsRenumberingHelper::add_ID_Pair(const int & Old_ID, const int & New_ID) throw (ClsRenumberingHelper_ErrorReporter) {

	typ_RenumberingMap::iterator iter ;

	if ( m_RenumberingMap.find(Old_ID) != m_RenumberingMap.end() ) {
		throw ClsRenumberingHelper_ErrorReporter() ;
	} ;

	for (iter = m_RenumberingMap.begin(); iter!=m_RenumberingMap.end(); iter++) {
		if (iter->second == New_ID) {
			throw ClsRenumberingHelper_ErrorReporter() ;
		} ;
	} ;

	m_RenumberingMap[Old_ID] = New_ID ;
} ;
//*******************************************************************************************************
int olSDL::ClsRenumberingHelper::get_Old_ID_from_New_ID(const int & New_ID) throw (ClsRenumberingHelper_ErrorReporter) {

	typ_RenumberingMap::const_iterator iter ;

	for (iter = m_RenumberingMap.begin(); iter!=m_RenumberingMap.end(); iter++) {
		if (iter->second == New_ID) {
			return (iter->first) ;
		} ;
	} ;

	throw ClsRenumberingHelper_ErrorReporter() ;
} ;
//*******************************************************************************************************
int olSDL::ClsRenumberingHelper::get_New_ID_from_Old_ID(const int & Old_ID) throw (ClsRenumberingHelper_ErrorReporter) {

	if ( m_RenumberingMap.find(Old_ID) == m_RenumberingMap.end() ) {
		throw ClsRenumberingHelper_ErrorReporter() ;
	} ;

	return m_RenumberingMap[Old_ID] ;
} ;
//*******************************************************************************************************
void olSDL::ClsRenumberingHelper::reset_RenumberingHelper() {

	m_RenumberingMap.clear() ;
} ;
//*******************************************************************************************************
