#ifndef olSDL_APP_VARS_H
#define olSDL_APP_VARS_H

#define APPL_INST_PATH "."

#include "SysSpec.h"

namespace olSDL {

	class ClassAppVars {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	string m_str_appl_inst_path ;
	string m_str_Debug_Dir ;

	string m_str_DefaultProjectsDir ;
	string m_str_Dummy_XML_File ;

	SysSpec* m_pSystemSpec ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------

	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClassAppVars() ;

	//============
	// getter
	SysSpec* get_SysSpec() ;

	string get_Appl_Inst_Path() ;
	string get_DebugDir() ;

	string get_DefaultProjectsDir() ;
	string get_Dummy_XML_File() ;

	//============
	//setter
	void set_SysSpec(SysSpec* const pSystemSpec) ;

	} ; // class ClassAppVars

} // END: namespace ol_SDL

#endif

