#ifndef olSDL_BASIC_TYPES_H
#define olSDL_BASIC_TYPES_H

using namespace std;

#include <list>
#include <string>

namespace olSDL{

	//=======================================================================
	class ClsPoint {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_x ;
	int m_y ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsPoint(int x, int y) ;

	//============
	// getter

	int get_x();
	int get_y();

	}; // class ClsPoint

	//=======================================================================
	class ClsRecPaS {
	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_x ;
	int m_y ;
	int m_width ;
	int m_height ;
	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsRecPaS(const int x, const int y, const int width, const int height) ;

	//============
	// setter
	void set_PaS(const int x, const int y, const int width, const int height) ;

	void set_PaS(const ClsRecPaS & PaS) ;

	//============
	// getter
	int get_x_left_up() const ;
	int get_y_left_up() const ;
	int get_width() const ;
	int get_height() const ;
	int get_x_right_down() const ;
	int get_y_right_down() const ;

	void get_PaS_as_IntList(list<int> & IntList) const ;
	list<int> get_PaS_as_IntList() const ;
	void get_BoundingBox(list<int> & IntList) const ;

	ClsRecPaS get_PaS() const ;


	// for testing
	string get_PaS_as_String( ) const ;

	} ; // class ClsRecPaS



} // END: namespace ol_SDL

#endif
