
#ifndef olSDL_OBJECT_WITH_MODEL_ID_H
#define olSDL_OBJECT_WITH_MODEL_ID_H

#include "MoEleBasicType.h"


namespace olSDL{

	class ClsObjectWithModel_ID {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_Model_ID ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsObjectWithModel_ID(const int Model_ID) ;
	// Copy

	//============
	// getter
	int get_Model_ID( ) const ;

	virtual olSDL::ClsMoEleType::e_MoEle get_MoEleType() const =0 ;

	} ; // class


	//=============================================================================
	// function object for use with "find_if" from <algorithm>

	class ObjectHasID {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_ID ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------

	//============
	//Constructor, Copy-Constructor, Assign-Op
	public:
	ObjectHasID(const int ID): m_ID(ID) { }

	bool operator() (const ClsObjectWithModel_ID * pObjectWithModel_ID) { return (pObjectWithModel_ID->get_Model_ID() == m_ID) ;} ;

	}; //class ObjectHasID



} // END: namespace ol_SDL


#endif
