
#ifndef olSDL_PAGE_OBJECT_H
#define olSDL_PAGE_OBJECT_H


namespace olSDL{

	class ClsPageObject {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_Page_ID ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op
	ClsPageObject(const int Page_ID) ;

	//============
	// getter
	int get_Page_ID() const ;

	} ; // class ClsPageObject


	//=============================================================================
	// function object for use with "find_if" from <algorithm>

	class ObjectOnPage {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_ID ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------

	//============
	//Constructor, Copy-Constructor, Assign-Op
	public:
	ObjectOnPage(const int ID): m_ID(ID) { }

	bool operator() (const  ClsPageObject * pPageObject) { return (pPageObject->get_Page_ID() == m_ID) ;} ;

	}; //class ObjectOnPage

} // END: namespace ol_SDL


#endif
