
#ifndef olSDL_RENUMBERING_HELPER_H
#define olSDL_RENUMBERING_HELPER_H

#include <map>

namespace olSDL {


	class ClsRenumberingHelper_ErrorReporter {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------

	public:
	enum e_ErrorType {not_specified} ;

	private:
		e_ErrorType m_ErrorType ;

	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsRenumberingHelper_ErrorReporter() ;
	ClsRenumberingHelper_ErrorReporter(e_ErrorType ErrorType) ;

	//============
	// getter
	e_ErrorType get_ErrorType() const ;

	} ;

	// ===================================================================
	// ===================================================================

	class ClsRenumberingHelper {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	typedef map<int, int> typ_RenumberingMap ;

	typ_RenumberingMap m_RenumberingMap ;


	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...

	// Copy

	// Assign

	// Des

	//============
	// getter
	int get_Old_ID_from_New_ID(const int & New_ID) throw (ClsRenumberingHelper_ErrorReporter) ;
	int get_New_ID_from_Old_ID(const int & Old_ID) throw (ClsRenumberingHelper_ErrorReporter) ;

	//============
	// setter
	void add_ID_Pair(const int & Old_ID, const int & New_ID) throw (ClsRenumberingHelper_ErrorReporter) ;
	void reset_RenumberingHelper() ;

	} ; // class


} // END: namespace ol_SDL


#endif
