
#ifndef olSDL_SDL_PR_WRITER_HELPER_H
#define olSDL_SDL_PR_WRITER_HELPER_H


#include <map>
#include <string>


namespace olSDL {

	class ClsSDL_PR_WriterHelper {

	private:
	typedef map<int, string> type_LabelMap ;

	protected:
	static const string LABEL_BASIC_NAME ;

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	int m_LabelCounter ;
	type_LabelMap m_LabelMap ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsSDL_PR_WriterHelper() ;

	// Copy

	// Assign

	// Des
	~ClsSDL_PR_WriterHelper() ;

	//============
	// getter
	bool StateMaSym_written(const int StateMaSymID) const ;
	string get_Label(const int StateMaSymID) const ;

	
	//============
	// setter
	bool set_StateMaSym_written(const int StateMaSymID) ;
	void reset_Helper() ;

	} ; // class


} // END: namespace ol_SDL


#endif
