
#ifndef olSDL_SYMS_H
#define olSDL_SYMS_H

#include "Symbol.h"


namespace olSDL{

	//========================================================================================
	//========================================================================================
	class ClsTextSym : public Symbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsTextSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	ClsTextSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const string content, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	// Des
	~ClsTextSym() ;

	//============
	// getter
	bool is_referencing_Symbol() const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsTextSym

	//========================================================================================
	//========================================================================================
	class ClsBlkInstRefSym : public Symbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsBlkInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	ClsBlkInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const string content, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	// Des
	~ClsBlkInstRefSym() ;

	//============
	// getter
	bool is_referencing_Symbol() const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsBlkInstRefSym

	//========================================================================================
	//========================================================================================
	class ClsBlkTypeRefSym : public Symbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsBlkTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	ClsBlkTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const string content, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	// Des
	~ClsBlkTypeRefSym() ;

	//============
	// getter
	bool is_referencing_Symbol() const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsBlkTypeRefSym

	//========================================================================================
	//========================================================================================
	class ClsProInstRefSym : public Symbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:

	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsProInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	ClsProInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const string content, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	// Des
	~ClsProInstRefSym() ;

	//============
	// getter
	bool is_referencing_Symbol() const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsProInstRefSym

	//========================================================================================
	//========================================================================================
	class ClsProTypeRefSym : public Symbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsProTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	ClsProTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const string content, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	// Des
	~ClsProTypeRefSym() ;

	//============
	// getter
	bool is_referencing_Symbol() const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsProTypeRefSym

	//========================================================================================
	//========================================================================================
	class ClsProcedureInstRefSym : public Symbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:

	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsProcedureInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	ClsProcedureInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     const int width, const int height, const string content, const int Page_ID,
		     const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	// Des
	~ClsProcedureInstRefSym() ;

	//============
	// getter
	bool is_referencing_Symbol() const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsProcedureInstRefSym


} // END: namespace ol_SDL


#endif
