package provide olSDL_Views 1

namespace eval olSDL_PageFrame {

}
##############################################################################
proc ::olSDL_PageFrame::ChanCompsOnPage {ObjArrName CanInfoArr \
	Channel_ID OldChannelCoords NewChannelCoords NewPageWidth NewPageHeight} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	######
	# calculate old RefPoi

	set ChanNameOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChannelName $OldChannelCoords]
	set ChanSourceSigOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceSig $OldChannelCoords]
	set ChanSourceConOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceCon $OldChannelCoords]
	set ChanDestSigOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestSig $OldChannelCoords]
	set ChanDestConOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestCon $OldChannelCoords]

	set OldRefPoi_x_Name [lindex $ChanNameOldRefPoi 0]
	set OldRefPoi_y_Name [lindex $ChanNameOldRefPoi 1]

	set OldRefPoi_x_SourceCon [lindex $ChanSourceConOldRefPoi 0]
	set OldRefPoi_y_SourceCon [lindex $ChanSourceConOldRefPoi 1]

	set OldRefPoi_x_DestCon [lindex $ChanDestConOldRefPoi 0]
	set OldRefPoi_y_DestCon [lindex $ChanDestConOldRefPoi 1]

	set OldRefPoi_x_SourceSig [lindex $ChanSourceSigOldRefPoi 0]
	set OldRefPoi_y_SourceSig [lindex $ChanSourceSigOldRefPoi 1]

	set OldRefPoi_x_DestSig [lindex $ChanDestSigOldRefPoi 0]
	set OldRefPoi_y_DestSig [lindex $ChanDestSigOldRefPoi 1]

	#
	####

	######
	# calculate new RefPoi

	set ChanNameNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChannelName $NewChannelCoords]
	set ChanSourceSigNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceSig $NewChannelCoords]
	set ChanSourceConNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceCon $NewChannelCoords]
	set ChanDestSigNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestSig $NewChannelCoords]
	set ChanDestConNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestCon $NewChannelCoords]

	set NewRefPoi_x_Name [lindex $ChanNameNewRefPoi 0]
	set NewRefPoi_y_Name [lindex $ChanNameNewRefPoi 1]

	set NewRefPoi_x_SourceCon [lindex $ChanSourceConNewRefPoi 0]
	set NewRefPoi_y_SourceCon [lindex $ChanSourceConNewRefPoi 1]

	set NewRefPoi_x_DestCon [lindex $ChanDestConNewRefPoi 0]
	set NewRefPoi_y_DestCon [lindex $ChanDestConNewRefPoi 1]

	set NewRefPoi_x_SourceSig [lindex $ChanSourceSigNewRefPoi 0]
	set NewRefPoi_y_SourceSig [lindex $ChanSourceSigNewRefPoi 1]

	set NewRefPoi_x_DestSig [lindex $ChanDestSigNewRefPoi 0]
	set NewRefPoi_y_DestSig [lindex $ChanDestSigNewRefPoi 1]

	#
	####

	####
	# get CompIDs

	set Chan_NameID [$CanvasPathName find withtag ChanName$Channel_ID]

	set Chan_SourceSigID [$CanvasPathName find withtag ChanSourceSig$Channel_ID]
	set Chan_SourceConID [$CanvasPathName find withtag ChanSourceCon$Channel_ID]

	set Chan_DestSigID [$CanvasPathName find withtag ChanDestSig$Channel_ID]
	set Chan_DestConID [$CanvasPathName find withtag ChanDestCon$Channel_ID]

	# get CompIDs
	####

	####
	# dx, dy

	set dx_Name [expr [lindex $ObjArr($Chan_NameID,PaS) 0] - $OldRefPoi_x_Name]
	set dy_Name [expr [lindex  $ObjArr($Chan_NameID,PaS) 1] - $OldRefPoi_y_Name]

	set dx_SourceCon [expr [lindex $ObjArr($Chan_SourceConID,PaS) 0] - $OldRefPoi_x_SourceCon]
	set dy_SourceCon [expr [lindex $ObjArr($Chan_SourceConID,PaS) 1] - $OldRefPoi_y_SourceCon]

	set dx_DestCon [expr [lindex $ObjArr($Chan_DestConID,PaS) 0] - $OldRefPoi_x_DestCon]
	set dy_DestCon [expr [lindex $ObjArr($Chan_DestConID,PaS) 1] - $OldRefPoi_y_DestCon]

	set dx_SourceSig [expr [lindex $ObjArr($Chan_SourceSigID,PaS) 0] - $OldRefPoi_x_SourceSig]
	set dy_SourceSig [expr [lindex $ObjArr($Chan_SourceSigID,PaS) 1] - $OldRefPoi_y_SourceSig]

	set dx_DestSig [expr [lindex $ObjArr($Chan_DestSigID,PaS) 0] - $OldRefPoi_x_DestSig]
	set dy_DestSig [expr [lindex $ObjArr($Chan_DestSigID,PaS) 1] - $OldRefPoi_y_DestSig]

	#
	####

	####
	# calculate New Position

	set NewPosition_x_Name [expr $NewRefPoi_x_Name + $dx_Name]
	set NewPosition_y_Name [expr $NewRefPoi_y_Name + $dy_Name]

	set NewPosition_x_SourceCon [expr $NewRefPoi_x_SourceCon + $dx_SourceCon]
	set NewPosition_y_SourceCon [expr $NewRefPoi_y_SourceCon + $dy_SourceCon]

	set NewPosition_x_DestCon [expr $NewRefPoi_x_DestCon + $dx_DestCon]
	set NewPosition_y_DestCon [expr $NewRefPoi_y_DestCon + $dy_DestCon]

	set NewPosition_x_SourceSig [expr $NewRefPoi_x_SourceSig + $dx_SourceSig]
	set NewPosition_y_SourceSig [expr $NewRefPoi_y_SourceSig + $dy_SourceSig]

	set NewPosition_x_DestSig [expr $NewRefPoi_x_DestSig + $dx_DestSig]
	set NewPosition_y_DestSig [expr $NewRefPoi_y_DestSig + $dy_DestSig]

	#
	####

	set PageCoords [list 0 0 $NewPageWidth $NewPageHeight]

	####
	# SourceCon
	set NewSourceConCoords [list $NewPosition_x_SourceCon $NewPosition_y_SourceCon \
		[expr int ( $NewPosition_x_SourceCon + [lindex $ObjArr($Chan_SourceConID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_SourceCon + [lindex $ObjArr($Chan_SourceConID,PaS) 3]) ] ]

	if { ! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewSourceConCoords] } { return false }
	#
	####

	####
	# SourceSig
	set NewSourceSigCoords [list $NewPosition_x_SourceSig $NewPosition_y_SourceSig \
		[expr int ( $NewPosition_x_SourceSig + [lindex $ObjArr($Chan_SourceSigID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_SourceSig + [lindex $ObjArr($Chan_SourceSigID,PaS) 3]) ] ]

	if { ! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewSourceSigCoords] } { return false }
	#
	####

	####
	# DestCon
	set NewDestConCoords [list $NewPosition_x_DestCon $NewPosition_y_DestCon \
		[expr int ( $NewPosition_x_DestCon + [lindex $ObjArr($Chan_DestConID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_DestCon + [lindex $ObjArr($Chan_DestConID,PaS) 3]) ] ]

	if { ! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewDestConCoords] } { return false }
	#
	####

	####
	# DestSig
	set NewDestSigCoords [list $NewPosition_x_DestSig $NewPosition_y_DestSig \
		[expr int ( $NewPosition_x_DestSig + [lindex $ObjArr($Chan_DestSigID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_DestSig + [lindex $ObjArr($Chan_DestSigID,PaS) 3]) ] ]

	if { ! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewDestSigCoords] } { return false }
	#
	####

	####
	# Name
	set NewNameCoords [list $NewPosition_x_Name $NewPosition_y_Name \
		[expr int ( $NewPosition_x_Name + [lindex $ObjArr($Chan_NameID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_Name + [lindex $ObjArr($Chan_NameID,PaS) 3]) ] ]

	if { ! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewNameCoords] } { return false }
	#
	####

	return true
}
##############################################################################
proc ::olSDL_PageFrame::ChannelsCompsOnPage {ObjArrName CanInfoArr \
	NewPageWidth NewPageHeight OldPaS NewPaS MovedSide SideCoor} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $OldPaS Old_x1 Old_y1 Old_x2 Old_y2
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $NewPaS New_x1 New_y1 New_x2 New_y2

	switch -exact $MovedSide {
		right {
			set CoorValue $Old_x2
		}
		bottom {
			set CoorValue $Old_y2
		}
		default {
			error "unknown side"
		}
	}
	# switch -exact $MovedSide

	set ChannelsOnBorder [::olSDL_Views::Channel::get_ChannelsOnBorder $ObjArrName $CanInfoArr $MovedSide $CoorValue]

	foreach ChanOnBorder $ChannelsOnBorder {


		set old_ChannelCoords $ObjArr($ChanOnBorder,Coords)


		switch -exact $MovedSide {
			right {
				if { $ObjArr($ChanOnBorder,SourceID) == "ENV" } {

					set new_ChannelCoords [ lreplace $ObjArr($ChanOnBorder,Coords) 0 1 \
						$New_x2 [lindex $ObjArr($ChanOnBorder,Coords) 1] ]

				} elseif { $ObjArr($ChanOnBorder,DestinationID) == "ENV" } {

					set new_ChannelCoords [ lreplace $ObjArr($ChanOnBorder,Coords) \
						[expr [llength $ObjArr($ChanOnBorder,Coords)] - 2] end \
						$New_x2 [lindex $ObjArr($ChanOnBorder,Coords) [expr [llength $ObjArr($ChanOnBorder,Coords)] - 1]  ] ]

				} else {
					error "prog error"
				}
			}
			bottom {
				if { $ObjArr($ChanOnBorder,SourceID) == "ENV" } {

					set new_ChannelCoords [ lreplace $ObjArr($ChanOnBorder,Coords) 0 1 \
						[lindex $ObjArr($ChanOnBorder,Coords) 0] $New_y2]

				} elseif { $ObjArr($ChanOnBorder,DestinationID) == "ENV" } {

					set new_ChannelCoords [ lreplace $ObjArr($ChanOnBorder,Coords) \
						[expr [llength $ObjArr($ChanOnBorder,Coords)] - 2] end \
						[lindex $ObjArr($ChanOnBorder,Coords) [expr [llength $ObjArr($ChanOnBorder,Coords)] - 2]  ] $New_y2]

				} else {
					error "prog error"
				}
			}
			default {
				error "unknown side moved"
			}
		}
		# switch -exact $MovedSide

		if { ! [::olSDL_PageFrame::ChanCompsOnPage $ObjArrName $CanInfoArr \
			$ChanOnBorder $old_ChannelCoords $new_ChannelCoords $NewPageWidth $NewPageHeight] } {

			return false
		}

	}
	# foreach ChanOnBorder $ChannelsOnBorder

	return true

}
##############################################################################
proc ::olSDL_PageFrame::ObjectsInPageFrameAndOnPage {ObjArrName CanInfoArr ShrinkZoneCoords \
	NewPageWidth NewPageHeight NewPageFramePaS MovedSide SideCoor} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set NewPageCoords [list 0 0 $NewPageWidth $NewPageHeight]
	set NewPageFrameCoords [::olSDL_ViewsCalcCoor::get_RecCoordsAsList_fromPaS $NewPageFramePaS]

	#############
	# check RecSym like TextSym, BlkInstRefSym, ...

	if { [::olSDL_Views::Obj_covered $CanvasPathName $ShrinkZoneCoords dummy selectableRec] } {
		::olSDL_Dialogs::PageOrFrameWarning "RecSym"
		return false
	}

	# END: check RecSym like TextSym, BlkInstRefSym, ...
	#############

	#############
	# check StateMaSym

	if { [::olSDL_Views::Obj_covered $CanvasPathName $ShrinkZoneCoords dummy selectableStateMaSym] } {
		::olSDL_Dialogs::PageOrFrameWarning "StateMaSym"
		return false
	}

	# END: check StateMaSym
	#############

	#############
	# check FlowLines

	set FlowLines [::olSDL_Views::FlowLine::get_AllFlowLines $CanInfoArr]

	foreach FlowLineID $FlowLines {

		switch -exact $MovedSide {
			"right" {
				if { ! [::olSDL_ViewsCalcCoor::LineInRectangle $ObjArr($FlowLineID,Coords) $NewPageFrameCoords] } {
					::olSDL_Dialogs::PageOrFrameWarning "FlowLine"
					return false
				}
			}
			"bottom" {
				if { ! [::olSDL_ViewsCalcCoor::LineInRectangle $ObjArr($FlowLineID,Coords) $NewPageFrameCoords] } {
					::olSDL_Dialogs::PageOrFrameWarning "FlowLine"
					return false
				}
			}
			default {
				error "unknown side moved"
			}
		}
		# switch -exact $MovedSide
	}
	#foreach FlowLineID $FlowLines

	# END: check FlowLines
	#############

	#############
	# check DecFlowLines

	set DecFlowLines [::olSDL_Views::FlowLine::get_AllDecFlowLines $CanInfoArr]

	foreach DecFlowLinesID $DecFlowLines {

		switch -exact $MovedSide {
			"right" {
				if { ! [::olSDL_ViewsCalcCoor::LineInRectangle $ObjArr($DecFlowLinesID,Coords) $NewPageFrameCoords] } {
					::olSDL_Dialogs::PageOrFrameWarning "DecFlowLine"
					return false
				}
			}
			"bottom" {
				if { ! [::olSDL_ViewsCalcCoor::LineInRectangle $ObjArr($DecFlowLinesID,Coords) $NewPageFrameCoords] } {
					::olSDL_Dialogs::PageOrFrameWarning "DecFlowLine"
					return false
				}
			}
			default {
				error "unknown side moved"
			}
		}
		# switch -exact $MovedSide
	}
	#foreach DecFlowLinesID $DecFlowLines

	# END: check DecFlowLines
	#############

	#############
	# check DecFlowLinesComp

	set DecFlowLineComps \
		[::olSDL_Views::FlowLine::get_AllCompsOfAllDecFlowLines $CanInfoArr]

	foreach CompID $DecFlowLineComps {
		set CompCoords [::olSDL_ViewsCalcCoor::get_RecCoordsAsList_fromPaS $ObjArr($CompID,PaS)]
		if { ! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $NewPageCoords $CompCoords ] } {
			::olSDL_Dialogs::PageOrFrameWarning "DecFlowLineComp"
			return false
		}
	}

	# END: check DecFlowLinesComp
	#############

	#############
	# NEU
	# check Channel Comp like Name, SigList, ....

	if { ! [::olSDL_PageFrame::ChannelsCompsOnPage $ObjArrName $CanInfoArr \
		$NewPageWidth $NewPageHeight $CanInfo(PageFramePaS) $NewPageFramePaS $MovedSide $SideCoor] } {

		::olSDL_Dialogs::PageOrFrameWarning "ChanComp"
		return false
	}

	# END: check Channel Comp like Name, SigList, ....
	#############

	#############
	# ALT
	# check Channel Comp like Name, SigList, ....

	#set ChanComps [::olSDL_Views::Channel::get_AllCompsOfAllChannels $CanInfoArr]

	#foreach CompID $ChanComps {
	#	set CompCoords [::olSDL_ViewsCalcCoor::get_RecCoordsAsList_fromPaS $ObjArr($CompID,PaS)]

	#	if { ! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $NewPageCoords $CompCoords ] } {
	#		::olSDL_Dialogs::PageOrFrameWarning "ChanComp"
	#		return false
	#	}
	#}
	# foreach CompID $ChanComps

	# END: check Channel Comp like Name, SigList, ....
	#############

	#############
	# check Channels

	set Channels [::olSDL_Views::Channel::get_all_channels $CanInfoArr]

	foreach ChanID $Channels {

		foreach {ChanPoint_x ChanPoint_y} $ObjArr($ChanID,Coords) {

			switch -exact $MovedSide {
				"right" {
					if { $ChanPoint_x != $SideCoor } {
						if { ! [::olSDL_ViewsCalcCoor::Point_in_Rectangle $ChanPoint_x $ChanPoint_y $NewPageFrameCoords] } {
							::olSDL_Dialogs::PageOrFrameWarning "Channel"
							return false
						}
					}
				}
				"bottom" {
					if { $ChanPoint_y != $SideCoor } {
						if { ! [::olSDL_ViewsCalcCoor::Point_in_Rectangle $ChanPoint_x $ChanPoint_y $NewPageFrameCoords] } {
							::olSDL_Dialogs::PageOrFrameWarning "Channel"
							return false
						}
					}
				}
				default {
					error "unknown side moved"
				}
			}
			# switch -exact $MovedSide
		}
		# foreach ChanPoint_x ChanPoint_y $ObjArr($ChanID,Coords)
	}
	#foreach ChanID $Channels

	# END: check Channels
	#############

	return true
}
########################################################################################################
proc ::olSDL_PageFrame::move_AllChannelOnBorderToEnvironment {ObjArrName CanInfoArr MovedSide OldPaS NewPaS} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $OldPaS Old_x1 Old_y1 Old_x2 Old_y2
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $NewPaS New_x1 New_y1 New_x2 New_y2

	switch -exact $MovedSide {
		right {
			set CoorValue $Old_x2
		}
		bottom {
			set CoorValue $Old_y2
		}
		default {
			error "unknown side"
		}
	}
	# switch -exact $MovedSide

	set ChannelsOnBorder [::olSDL_Views::Channel::get_ChannelsOnBorder $ObjArrName $CanInfoArr $MovedSide $CoorValue]

	foreach ChanOnBorder $ChannelsOnBorder {

		switch -exact $MovedSide {
			right {

				if { $ObjArr($ChanOnBorder,SourceID) == "ENV" } {

					# move ChanComp
					::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
						$ChanOnBorder \
						0 $New_x2 [lindex $ObjArr($ChanOnBorder,Coords) 1] \
						$CanInfo(PageWidth) $CanInfo(PageHeight)

					::olSDL_Views::Channel::modify_SourceConnectionPoint_in_Tcl_and_Model \
						$ObjArrName $CanInfoArr $ChanOnBorder $New_x2 \
						[lindex $ObjArr($ChanOnBorder,Coords) 1]

				} elseif { $ObjArr($ChanOnBorder,DestinationID) == "ENV" } {

					# move ChanComp
					::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
						$ChanOnBorder \
						[expr int ( ([llength $ObjArr($ChanOnBorder,Coords)] / 2.0) -1) ] \
						$New_x2 [lindex $ObjArr($ChanOnBorder,Coords) [expr [llength $ObjArr($ChanOnBorder,Coords)] - 1]  ] \
						$CanInfo(PageWidth) $CanInfo(PageHeight)

					::olSDL_Views::Channel::modify_DestinationConnectionPoint_in_Tcl_and_Model \
						$ObjArrName $CanInfoArr $ChanOnBorder $New_x2 \
						[lindex $ObjArr($ChanOnBorder,Coords) [expr [llength $ObjArr($ChanOnBorder,Coords)] - 1]  ]

				} else {
					error "prog error"
				}
			}
			bottom {
				if { $ObjArr($ChanOnBorder,SourceID) == "ENV" } {

					# move ChanComp
					::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
						$ChanOnBorder 0 \
						[lindex $ObjArr($ChanOnBorder,Coords) 0] $New_y2 \
						$CanInfo(PageWidth) $CanInfo(PageHeight)

					::olSDL_Views::Channel::modify_SourceConnectionPoint_in_Tcl_and_Model \
						$ObjArrName $CanInfoArr $ChanOnBorder \
						[lindex $ObjArr($ChanOnBorder,Coords) 0] \
						$New_y2

				} elseif { $ObjArr($ChanOnBorder,DestinationID) == "ENV" } {


					# move ChanComp
					::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
						$ChanOnBorder [expr int ( ([llength $ObjArr($ChanOnBorder,Coords)] / 2.0) -1) ] \
						[lindex $ObjArr($ChanOnBorder,Coords) [expr [llength $ObjArr($ChanOnBorder,Coords)] - 2]  ] $New_y2 \
						$CanInfo(PageWidth) $CanInfo(PageHeight)

					::olSDL_Views::Channel::modify_DestinationConnectionPoint_in_Tcl_and_Model \
						$ObjArrName $CanInfoArr $ChanOnBorder \
						[lindex $ObjArr($ChanOnBorder,Coords) [expr [llength $ObjArr($ChanOnBorder,Coords)] - 2]  ] \
						$New_y2

				} else {
					error "prog error"
				}
			}
			default {
				error "unknown side moved"
			}
		}
		# switch -exact $MovedSide


		::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $ChanOnBorder

		# draw Channel
		 ::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
			$ObjArr($ChanOnBorder,Coords) \
			$ObjArr($ChanOnBorder,DelayType) $ObjArr($ChanOnBorder,DirectionType) \
			true $ChanOnBorder \
			NewChannel_ID
	}
	# foreach ChanOnBorder $ChannelsOnBorder
}
########################################################################################################
proc ::olSDL_PageFrame::modifyPageFramePaS_in_Canvas {ObjArrName CanInfoArr} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	########
	# scrollregion

	::olSDL_Views::set_PageScrollregion $CanvasPathName $CanInfo(PageWidth) $CanInfo(PageHeight)

	# END: scrollregion
	########

	########
	# PageFrame Environment

	$CanvasPathName coords $CanInfo(EnvironmentRectangle) 0 0 $CanInfo(PageWidth) $CanInfo(PageHeight)

	# END: PageFrame Environment
	########

	################
	# PageFrame Background

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $CanInfo(PageFramePaS) t_x1 t_y1 t_x2 t_y2

	$CanvasPathName coords $CanInfo(BackgroundRectangle) $t_x1 $t_y1 $t_x2 $t_y2

	# END : setup PageFrame Background
	################
}
########################################################################################################
proc ::olSDL_PageFrame::store_Page_and_PageFrame_in_Tcl_and_Model {ObjArrName CanInfoArr PageBeforeFrame NewPageWidth NewPageHeight NewFramePaS} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanInfo(PageWidth) $NewPageWidth
	set CanInfo(PageHeight) $NewPageHeight
	set CanInfo(PageFramePaS) $NewFramePaS

	if { $PageBeforeFrame } {

		modify_PageHeight_in_Model $CanInfo(Dia_Model_ID) $CanInfo(PageID) $CanInfo(PageHeight)

		modify_PageWidth_in_Model $CanInfo(Dia_Model_ID) $CanInfo(PageID) $CanInfo(PageWidth)

		modify_PageFramePaS_in_Model $CanInfo(Dia_Model_ID) $CanInfo(PageID) \
			[lindex $CanInfo(PageFramePaS) 0] [lindex $CanInfo(PageFramePaS) 1] \
			[lindex $CanInfo(PageFramePaS) 2] [lindex $CanInfo(PageFramePaS) 3]

	} else {

		modify_PageFramePaS_in_Model $CanInfo(Dia_Model_ID) $CanInfo(PageID) \
			[lindex $CanInfo(PageFramePaS) 0] [lindex $CanInfo(PageFramePaS) 1] \
			[lindex $CanInfo(PageFramePaS) 2] [lindex $CanInfo(PageFramePaS) 3]

		modify_PageHeight_in_Model $CanInfo(Dia_Model_ID) $CanInfo(PageID) $CanInfo(PageHeight)

		modify_PageWidth_in_Model $CanInfo(Dia_Model_ID) $CanInfo(PageID) $CanInfo(PageWidth)
	}

}
########################################################################################################
proc ::olSDL_PageFrame::store_Page_and_PageFrame_in_Tcl_and_Model_and_Redraw {ObjArrName CanInfoArr PageBeforeFrame \
	NewPageWidth NewPageHeight NewFramePaS} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	store_Page_and_PageFrame_in_Tcl_and_Model $ObjArrName $CanInfoArr $PageBeforeFrame $NewPageWidth $NewPageHeight $NewFramePaS


	# draw PageFrame
	::olSDL_ViewsDrawMethods::draw_PageFrame $CanvasPathName $CanInfo(PageFramePaS) true $CanInfo(PageFrameCanID) dummy

	# move PageIndex
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $CanInfo(PageFramePaS) Fr_x1 Fr_y1 Fr_x2 Fr_y2
	$CanvasPathName coords $CanInfo(PageIndexCanID) [expr $Fr_x2 - 5] [expr $Fr_y1 + 4]

	# change Scrollregion, Environment and Background
	::olSDL_PageFrame::modifyPageFramePaS_in_Canvas $ObjArrName $CanInfoArr

	# indicator
	::olSDL_MainMenu::update_Indicator
	
}
########################################################################################################


