/******************************************************************************/
/***         Header file for freechoice.c                                   ***/
/***       Praktikum Werkzeuge zur Analyse von Petri-Netzen, SS 1992        ***/
/***      Version 2.0 ( new data types )      Stefan Roemer 10.05.1993      ***/
/******************************************************************************/

#ifndef __FREECHOICE_H__
#define __FREECHOICE_H__

#include "neunetze.h"

/******************************************************************************/
/* Check if given net has free choice property.                               */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern bool FC( LMPNet );

#else

extern bool FC( /* LMPNet Net */ );

#endif 

/******************************************************************************/

#endif  /* __FREECHOICE_H__ */

/******************************************************************************/
/* END OF FILE freechoice.h                                                   */
/******************************************************************************/

