// HLBox.h
// Highlevel-Boxs fr den Netzeditor
// Burkhard Bieber 1995
// last-update: 13.09.95

#ifndef __HLBOX_H__
#define __HLBOX_H__

  //**********
  // Includes
  //**********

#include "../Low/Box.h"
#include "../Low/Net.h"

  //*********
  // Klassen
  //*********

class HLBox : public Box {
  protected:
    virtual void Write(ostream &f) const;
    virtual void ReadOptional(istream &f);
  public:
    virtual HLBox *asHLBox() const;
    HLBox(const Net &n, const String &Type="HLBox");
    HLBox(const HLBox &b);
    virtual int ObjectGet(Tcl_Interp *ip, int argc, CONST char *argv[]);
    virtual int ObjectSet(Tcl_Interp *ip, int argc, CONST char *argv[]); 
};  // class HLBox

  //*******************
  // Methoden (inline)
  //*******************

inline
HLBox::HLBox(const HLBox &b) : Box(b)
{
  // Nix
}  // HLBox::HLBox

inline  HLBox *
HLBox::asHLBox() const
{
  return (HLBox *) this;
}  // HLBox::asHLBox

#endif  // #ifndef __HLBOX_H__

  //*** Dateiende HLBox.h ***

