// Templates.cc
// Tobias Himstedt 1995
// Burkhard Bieber 1995
// Cecile Bui Thanh: added template class VHMap<Link> (2001)
// last-update: Nov. 2001

  //**********
  // includes
  //**********

#include "../include/SLStack.h"
#include "HLNet.h"

  //***********
  // templates
  //***********

template class OSLSet<Val>;
template class Map<String, String>;
template class VHMap<String, String>;

  // Templates fr Bindungen
template class Map<String, Val>;
template class VHMap<String, Val>;

  // Templates fr Typen
template class SET<Val>;
template class VHSet<Val>;

  // Fr Multimengen
template class Map<Val, int>;
template class VHMap<Val, int>;
template class MultiSET<Val>;

template class Map<String, int>;
template class VHMap<String, int>;
template class MultiSET<String>;

template int Equal(const Val &, const Val &);

template class Stack<Val>;

template class SLListNode<Val>;
template class SLList<Val>;
template class SLStack<Val>; 

template class SLListNode<VTNode>;
template class SLList<VTNode>;

template class Map<String, VHSet<Val> >;
template class Map<Val, VHSet<Val> >;
template class VHMap<String, VHSet<Val> >;
template class VHMap<Val, VHSet<Val> >;

template class Map<String, OSLSet<Val> >;
template class VHMap<String, OSLSet<Val> >;

template int Compare(const Val &, const Val &);

template class Map<String, Tupel>;

template class VHMap<String, Tupel>;

  // Templates for asynchronous links
template class Map<LinkTerm,int>;
template class VHMap<LinkTerm,int>;
template class MultiSET<LinkTerm>;

template class Map<String, HLTransition *>;
template class VHMap<String, HLTransition *>;

//template class SET<Val>;
//template class VHSet<Val>;
  // template class SET<Tupel>;
  // template class VHSet<Tupel>;
  // template int Equal(const Tupel &v1, const Tupel &v2);

  //*** Dateiende Templates.cc ***

