// Link.cc
// Asynchronous links
//-----------------------------------------
// class Link: Link symbols
// class LinkTerm: Valued link term
//-----------------------------------------
// Cecile Bui Thanh 2001
// last-update: Dec. 2001

#include "Link.h"

int
Link::operator ==(const Link l) const
{
   String l_name = l.get_name();
   return (l_name==my_name);
}


ostream &
operator <<(ostream &f, const Link &l) 
{
  l.Write(f);
  return f;
}  // operator <<


void
Link::Write(ostream &f) const
{
  f << my_name;
  f << "\"" << my_string_type << "\"";
  f << endl;
} // Link::Write(ostream &f)


LinkTerm::LinkTerm(const String &name, const String &args):
my_name(name), args_string(args)
{
  String tmp = args;
  if (tmp == "")
       my_args = *(new Val(dot));
  else my_args = StringToVal(tmp);

}



