// Templates.cc
// Forwards fr Templates
// Tobias Himstedt 1995
// Burkhard Bieber 1995/96
// last-update: 12.01.96

  //**********
  // includes
  //**********

#include "Net.h"

  //***********
  // templates
  //***********

  // String-Mengen
template class SET<String>;
template class VHSet<String>;
  // Kanten
template class Map<String, Edge *>;
template class VHMap<String, Edge *>;
  // Knoten
template class Map<String, Vertex *>;
template class VHMap<String, Vertex *>;
  // Blcke
template class Map<String, Block *>;
template class VHMap<String, Block *>;
  // Boxen
template class Map<String, Box *>;
template class VHMap<String, Box *>;
  // Stellen
template class Map<String, Place *>;
template class VHMap<String, Place *>;
  // Transitionen
template class Map<String, Transition *>;
template class VHMap<String, Transition *>;
  // Phantomtransitionen
template class Map<String, PTransition *>;
template class VHMap<String, PTransition *>;
  // Netze
template class Map<String, Net *>;
template class VHMap<String, Net *>;
template class Map<String, HLNet *>;
template class VHMap<String, HLNet *>;
  // Vergleichsfunktionen
template int   Equal(const String &, const String &);
template int   Equal(const int &, const int &);
  // Titel/Texte
template class Map<int, Net::Title>;
template class VHMap<int, Net::Title>;
  // Netzkomponentenreihenfolge
template class Map<String, NetFileOrder *>;
template class VHMap<String, NetFileOrder *>;

template class Map<int, int>;
template class VHMap<int, int>;

  // Templates for asynchronous links
template class Map<String,Link>;
template class VHMap<String,Link>;

template class Map<String, HLPlace *>;
template class VHMap<String, HLPlace *>;

  //*** Dateiende Templates.cc ***

