#ifndef PLACE
#define PLACE

#include <strstream>
#include <string>
#include "vertex.h"
#include "val.h"

const string PlacePrefix = "P";

class place : public vertex {
  protected:
    static int place_counter;
    set<val, less<val> > type;
    multiset<val, less<val> > marking;
    string type_string;
    string marking_st;

  public:
    place();
    place(string n);
    // TODO org:      virtual ~place() {};
    // TODO test:             ~place() {};
    virtual ~place() {};
    place(istrstream &os);

    virtual const string& PreFix() const;
    virtual void SetMaxId(int id);

    void StringToType(string s);
    void add(Tupel &va, string s);
    void StringToSet(string s, set<val, less<val> > &set);
    void StringRangeAppendSet(string range, set<val, less<val> > &set) const;
    void StringToMultiSet(string s, multiset<val, less<val> > &set);
    void StringRangeAppendMultiSet(string range, multiset<val, less<val> > &set) const;
    multiset<val, less<val> > Marking(void) {return marking;};
    set<val, less<val> > Type(void) {return type;};
    string MarkingString(void) {return marking_st;};
    string Markierung(void);
    string TypeString(void) {return type_string;};
    void SubtractMarking(multiset<val, less<val> > &smark);
    void AddMarking(multiset<val, less<val> > &smark);
    void ChangeMarking(string &mark) {StringToMultiSet(mark, marking);};
    void ChangeType(string &typ) {StringToSet(typ, type);};
};

#endif
