#include "transition.h"

int transition::trans_counter = 0;

transition::transition() : valueterm("tt") {
}

transition::transition(string n) : valueterm("tt") {
  name = n;
}

transition::transition(istrstream &os) : valueterm("tt") {
  char c;
  int x,y;
  string temp;

  read(os);
  c = os.peek();
  while(c != '\n') {
    os.get(c);
    temp = "";
    switch(c) {
      case 'n':
      case 'a':
      case 'h':
      case 'j':
                os >> x >> c >> y;
                break;
      case 'b':
      case 'R':
      case 'u':
      case 'P':
      case 'i': {
                  os >> c;
                  os >> c;
                  while(c != '"') {
                    temp += c;
                    os.get(c);
                  }
                  break;
                }
      case 'g': {
                  os >> c;
                  os >> c;
                  while(c != '"') {
                    temp += c;
                    os.get(c);
                  }
                  string vt(temp.c_str());
                  valueterm.ChangeTerm(vt);
                  break;
                }
      case 'S':
                break;
    }
    c = os.peek();
  }
}  // transition::transition

inline const string &
transition::PreFix() const
{
  return TransitionPrefix;
}  // transition::PreFix

inline void
transition::SetMaxId(int nr)
{
  trans_counter = (nr>trans_counter) ? nr+1 : trans_counter;
}  // transition::SetMaxId

void
transition::ChangeValueTerm(string &vt)
{
  valueterm.ChangeTerm(vt);
}  // transition::ChangeValueTerm

