#ifndef TRANSITION
#define TRANSITION

#include <string>
#include <strstream>
#include "vertex.h"
#include "val.h"

const string TransitionPrefix = "T";

class transition : public vertex {
  protected:
    static int trans_counter;
    VT valueterm;

  public:
    transition();
    transition(string n);
    // TODO org:      virtual ~transition() {};
    // TODO test:             ~transition() {};
    virtual ~transition() {};
    transition(istrstream &os);

    virtual const string& PreFix() const;
    virtual void SetMaxId(int id);
    VT ValueTerm() {return valueterm;};
    val EvaluateVT(Binding &b) {return valueterm.Evaluate(b);};
    void ChangeValueTerm(string &vt);
};

#endif
