#ifndef __CUTOFF_MM_H__
#define __CUTOFF_MM_H__

#include "global.h"

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

Event insert_event_with_ce_edges( LMPNet unfold_net, Transition tr_org );

#else

Event insert_event_with_ce_edges( unfold_net, tr_org );

#endif

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int IsNotCutoffPoint_LIST( LIST finalStateList, Event event );

#else

int IsNotCutoffPoint_LIST( finalStateList, event );

#endif

/****************************************************************************/
/* Berechnung des Endzustandes eines Ereignisses ( bzw. der damit verbunde- */
/* nen lokalen Konfiguration ).                                             */
/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LIST FinalState_LIST( Event event, LMPNet unfold_net );

#else

LIST FinalState_LIST( event, unfold_net );

#endif

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int IsNotCutoffPoint_ARRAY( LIST finalStateList, Event event );

#else

int IsNotCutoffPoint_ARRAY( finalStateList, event );

#endif

/*****************************************************************************/
/* Berechnung des Endzustandes eines Ereignisses ( bzw. der damit verbunde-  */
/* nen lokalen Konfiguration ).                                              */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LIST FinalState_ARRAY( Event event, LMPNet unfold_net );

#else

LIST FinalState_ARRAY( event, unfold_net );

#endif

/*****************************************************************************/
/* Berechnung des Endzustandes eines Ereignisses ( bzw. der damit verbunde-  */
/* nen lokalen Konfiguration ).                                              */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LIST FinalState_MARKING( Event event, LMPNet unfold_net );

#else

LIST FinalState_MARKING( event, unfold_net );

#endif

#endif /* __CUTOFF_MM_H__ */
