#ifndef __HASH_H__
#define __HASH_H__

#include "global.h"

/* Data structure: linear list for storing state lists. */
typedef struct hash_elem_
  {
    LIST              list;
    Cardinal32        minConfigSize;
    Event             event;
    struct hash_elem_ *next;
  } HASH_ELEM,
    *HASH;

                   /* Im Hash werden alle Konfigurationen gespeichert */
extern HASH        * GL_hashTable;
extern Cardinal32  GL_hashIndex;

Cardinal32 hash_size(void);

#if defined(__STDC__) || defined(__cplusplus)

void hash_alloc( Cardinal32 places );

#else

void hash_alloc( places );

#endif

#if defined(__STDC__) || defined(__cplusplus)

void hash_delete( HASH list );

#else

void hash_delete( list );

#endif

#if defined(__STDC__) || defined(__cplusplus)

void hash_index_list( LIST list );

#else

void hash_index_list( list );

#endif

#if defined(__STDC__) || defined(__cplusplus)

void hash_index_bit( BIT_ARRAY array );

#else

void hash_index_bit( array );

#endif

#if defined(__STDC__) || defined(__cplusplus)

void hash_show( LMPNet net );

#else

void hash_show( net );

#endif

/****************************************************************************/

#endif /* __HASH_H__ */
