#ifndef __QUEUE_H__
#define __QUEUE_H__

#include "global.h"

/*****************************************************************************/

void init_queue(void);

void delete_queue(void);

bool queue_not_empty(void);

/****************************************************************************/
/* Remove first event from queue */

#if defined(__STDC__) || defined(__cplusplus)

Event pop_queue( void );

#else

Event pop_queue( );

#endif

/****************************************************************************/
/* Insert event in queue */

#if defined(__STDC__) || defined(__cplusplus)

void insert_queue( Event event );

#else

void insert_queue( event );

#endif

/*****************************************************************************/

#endif /* __QUEUE_H__ */
