SRC1="../../../Examples/*.ll_net"
SRC2="[!ctu]*.ll_net"
#SRC3="[ctu]*.ll_net"
DEST="test?.output"

rm -f $DEST

for i in ${SRC1}; do
  echo Checking $i;
  echo $i >>test1.output;
  ../Unfold -T $i -s >>test1.output;
#  /opt/pep/bin/EVunfold -c -T $i -s >>test1.output;
done

for i in ${SRC2}; do
  echo Checking $i;
  echo $i >>test2.output;
  ../Unfold -T $i -s >>test2.output;
#  /opt/pep/bin/EVunfold -c -T $i -s >>test2.output;
done

for i in ${SRC3}; do
  echo Checking $i;
  echo $i >>test3.output;
  ../Unfold -T $i -s >>test3.output;
done

for i in 1 2; do
if (sed s/time.*//g test$i.output|grep -v allocated|diff -w test$i.correct -); then
  echo Test $i passed;
  rm -f test$i.output;
else
  echo Test $i failed for some file;
fi
done
