#!/bin/sh

SRC="../../../Examples/*.bpn2"
DEST="*.bpn2_exp"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i;
  $TIME ../b2b $i `basename ${i}`_exp
done

#check correctness
for i in ${DEST}; do
  if `diff $i $i.correct >/dev/null`; then
    rm $i;
    echo File $i passed...
  else
    echo File $i failed...
    echo `pwd`/$i >>$LOG;
  fi
done
