/******************************************************************************/
/* FILE evaltree.h                                                            */
/*                                                                            */
/* Martin Ackermann, Winter 96/97                                             */
/******************************************************************************/

#ifndef __EVALTREE_H__
#define __EVALTREE_H__

#include "compose.h"

/******************************************************************************/
/* globale Variablen                                                          */
/******************************************************************************/

extern Cardinal min_local_blk;


/******************************************************************************/
/* Globale Funktionen                                                         */
/******************************************************************************/

extern M_Net     Block2Net(TreeNode*);
extern Integer*  Set_Parser2Intern(Set);
extern void	 RenameRefPars(SymTabEntry*,char*);
extern decl_type HandleDecls(SymTabEntry *ptr, SymTabEntry* *block_entry);
extern void	 HandlePars(SymTabEntry*,M_Net*);
extern Integer	 HandleExpr(TreeNode*);

#endif /* __EVALTREE_H__ */

/******************************************************************************/
/* END OF FILE evaltree.h                                                     */
/******************************************************************************/
