#!/bin/sh

SRC="*.bpn2"
DEST="*.hl_net *hl_ref"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i;
  $TIME ../bpn2mnet $i -p=`basename $i .bpn2`.hl_net -z=`basename $i .bpn2`.bpn2_hl_ref
done

#check correctness
for i in ${DEST}; do
  if `diff $i $i.correct >/dev/null`; then
    rm $i;
    echo File $i passed...
  else
    echo File $i failed...
    echo `pwd`/$i >>$LOG;
  fi
done
