/******************************************************************************/
/* FILE frontend.h                                                            */
/* Burkhard Graves, 10.10.93                                                  */
/* Lars Jenner, Juni 1994                                                     */
/* Stephan Merkel, Feb. 95                                                    */
/* Martin Ackermann, Winter 1996/97                                           */
/******************************************************************************/

#ifndef __FRONTEND_H__
#define __FRONTEND_H__

#include <stdio.h>
#include "../frontend/function.h"
#include "symtab.h"
#include "tree.h"

/******************************************************************************/
/* Globale Datenstrukturen                                                    */
/******************************************************************************/

extern FILE *yyin,*yyout;

extern bool GL_Frags,
	    GL_OldSyn,
	    GL_ProcDecl,
	    GL_ProcCall,
            GL_ExplFree,
            GL_ParserMsg;

extern int num_old_syn;

extern TreeNode *tree;

/******************************************************************************/
/* Globale Funktionen                                                         */
/******************************************************************************/

extern int bpn2parse PROTO (( FILE * source, FILE * target, FILE *err ));


#endif /* __FRONTEND_H__ */

/******************************************************************************/
/* END OF FILE frontend.h                                                     */
/******************************************************************************/
