/*****************************************************************************/
/* unfoldHL.h                                                                */
/*****************************************************************************/


#ifndef __UNFOLDHL_H__
#define __UNFOLDHL_H__

/*****************************************************************************/

#include "multiset.h"
#include "mtupel.h"

/*****************************************************************************/

#define FL_REMOVE_ARCS		1
#define FL_WRITE_BLOCKS		2
#define FL_WRITE_PHANTOM	4
  
/*****************************************************************************/

#define V_FALSE (Integer) 0x8000
#define V_TRUE  (Integer) 0x8001
#define V_DOT   (Integer) 0x8002

extern Integer    *V_Dummy;
extern Cardinal32 GLO_line;
extern MultiSet   annovarset,
                  boundset;
extern MTupel	  *currvalue;

/*****************************************************************************/

extern Integer* V_create_copy(Integer*);
extern void V_insert_value(Integer**, Integer);
extern void V_insert_interval(Integer**, Integer, Integer);

/*****************************************************************************/

#endif /* __UNFOLDHL__ */

/*****************************************************************************/
/* END OF FILE unfoldHL.h                                                    */
/*****************************************************************************/

