/*****************************************************************************/
/* mtupel.h                                                                  */
/*****************************************************************************/

#ifndef __MTUPEL_H__
#define __MTUPEL_H__

#include "memlib.h"

typedef struct
{
	Cardinal count;
	Cardinal realsize;
	Integer* place;
} MTupEl, *MTupel;

typedef struct
{
	Cardinal count;
	Cardinal realsize;
	Integer** place;
} *MPTupel;

#define MT_Place(mt,num) ((mt)->place[num])
#define MT_PlaceP(mt,num) ((M_Place)(mt)->place[num])
#define MT_PlaceT(mt,num) ((M_Transition)(mt)->place[num])
#define MT_PlaceMPT(mt,num) ((MPTupel)(mt)->place[num])

extern MTupel MT_Create();
extern void MT_AddValue(MTupel mt, Integer what);

extern MPTupel MPT_Create();
extern void MPT_AddValue(MPTupel mt, Integer* what);

#define MPTT_AddValue(mt,what) MPT_AddValue(mt,(Integer *)what)

#endif /* __MTUPEL_H__ */

