%option noyywrap
%{
#include <stdlib.h>
#include "global.h"

int tokenvalue = NONE;
int counter = 0;
FILE *file;

%}
ID	[A-Za-z0-9]+((\+|-)[A-Za-z0-9]+)*
%%
[\ \t\n]+     ;
\%.*\n	  ;
{ID}(((<|>)=?)|==|!=)({ID})    { 
             file = fopen("merke_define","a"); 
             fprintf(file,"#define p%d (%s)\n",counter,yytext); 
             fclose(file); 
             return(AUSSAGE); }
"&&"       { return(AND); }
"!"        { return(NOT); }
"||"       { return(OR); }
"->"       { return(IMPLI); }
"<->"      { return(EQUIV); }
"[]"       { return(ALWAYS); }
"<>"       { return(EVENTU); }
"U"        { return(UNTIL); }
"V"        { return(CONTRA); }
"("        { return(OPEN); }
")"        { return(CLOSE); }
.          { tokenvalue = yytext[0]; return(NONE); }
%%
