#include <stdlib.h>
#include <stdio.h>
#include "rw_prefix.h"
#include "maxconf.h"

int main(int argc, char* argv[])
{
  if (argc<2 || argc>3)
  {
    printf("Usage: max_conf <filename> [outfile]\n");
    printf("Calculates the maximal configurations contained in finite prefix filename\n");
    printf("and outputs them to outfile or stdout.\n");
    exit(1);
  }
  
  if (argc==3)
    outfile=fopen(argv[2],"w");
  else
    outfile=stdout;
  configs(readPrefix(argv[1], NULL, NULL));
  if (outfile != stdout)
    fclose(outfile);
  exit(0);
}

