%option noyywrap
%option nounput
%{
#include "occ_net.h"
#include "tree.h"
#include "mc.tab.h"


%}

ID	[_[:alnum:]]
%%

[ \t\n]+	;
%.*		;
[_[:alpha:]]{ID}+ { if ((yylval.wert=GetPlNumname(yytext))==0)
		  Fatal("Scanner(): Place name unknown!");
		return PLACE;
		}
!		return FORALL;
\?		return EXISTS;
-		return NOT;
\*		return AND;
\+		return OR;
1		return TRUE;
0		return FALSE;
\^		return DIAMOND;
#		return BOX;
=>		return IMPL;
\<=>		return IFF;
\.		return 0;
.		return yytext[0];
