#!/bin/sh

SRC1="*.mci"
SRC2="../../../Examples/*.mci"
DEST=test.output
DEST_CORRECT=test.correct

rm -f $DEST

#create output
for i in ${SRC1}; do
  echo Checking $i;
  echo Checking $i >>$DEST;
  ../maxconf $i >>$DEST;
done
for i in ${SRC2}; do
  echo Checking $i;
  echo -n Checking $i >>$DEST;
  ../maxconf $i | wc | cut -c 1-7 >>$DEST;
done

#check correctness
  diff $DEST $DEST_CORRECT|wc
  if `diff $DEST $DEST_CORRECT >/dev/null`; then
    rm $DEST;
    echo Passed ...;
  else
    echo Failed ...;
  fi
