#ifndef __PEP_STRINGS_H__
#define __PEP_STRINGS_H__

#include "memlib.h"
#include <string.h>

/*****************************************************************************/
/*                    String-Vergleichsfunktionen                            */
/*****************************************************************************/

#define Strcpy( _STR1_, _STR2_ ) strncpy( _STR1_, _STR2_, NAMELENGTH )

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
extern bool (* Kleiner)( char *, char * );
extern bool (* Gleich)( char *, char * );
extern void strcmp_lexgraph( void );
extern void strcmp_strcmp( void );
#else
extern bool (* Kleiner)();
extern bool (* Gleich)();
extern void strcmp_lexgraph();
extern void strcmp_strcmp();
#endif

/*-------------------------------------------------------------------------*/
/*-- wandelt in str Gross- in Kleinbuchstaben um und gibt das Ergebnis   --*/
/*-- zurueck                                                             --*/

#if defined(__STDC__) || defined(__cplusplus)

extern char *StrLower( char *str );

#else

extern char *StrLower();

#endif
 
#endif /* __PEP_STRINGS_H__ */
