/**************************************************************************/
/* pep2pnml.c                                                             */
/* Converts pnml and pep net files in each direction.                     */
/**************************************************************************/

#include <string.h>
#include "convertPEP.h"
#include "rw_pnml.h"

int main( int argc, char **argv )
  {

    LMPNet net; 
    FILE* file;

    if (( argc > 4 )||(argc < 3))
      {
        printf( "Usage: %s [-p] <Infile> <Outfile> !\n", *argv );
	printf( "-p: produce PNML file\n");
        exit ( 1 );
      } /* if */

    CM_storeCoordinates=True;
    if (argv[1][0]=='-' && argv[1][1]=='p')
    {
    net = read_PEP( argv[2] );
    file=fopen (argv[3], "w");
    writePNML( file, net);
    }
    else
    {
    net = readPNML(argv[1]);
    if (net)
      write_new_PEP(net, argv[2]);
    }

//    remove_net( &net );
    exit ( 0 );

} /* main() */

