#ifndef __PRACT_H__
#define __PRACT_H__

#include "neunetze.h"

#if defined(__STDC__) || defined(__cplusplus)
extern LMPNet praktikum_ini( char * );
#else
extern LMPNet praktikum_ini();
#endif
        /* Argumente: char * filename */
        /* initialisiert die Matrix 'net' mit dem im Praktikums - Format     */
        /*  abgelegten Netz mit Namen 'netname'.                             */

#if defined(__STDC__) || defined(__cplusplus)
extern void write_matrix( LMPNet, char * );
#else
extern void write_matrix();
#endif
        /* Argumente: LMPNet net, char * filename                            */
        /* schreibt die Inzidenzmatrix des Netzes 'net' in die Datei         */
        /* 'filename'.                                                       */

#if defined(__STDC__) || defined(__cplusplus)
extern void write_netmarking( LMPNet, char * );
#else
extern void write_netmarking();
#endif
        /* Argumente: LMPNet net, char * filename                            */
        /* haengt die Anfangsmarkierung des Netzes 'net' an die Datei        */
        /* 'filename' an.                                                    */

#if defined(__STDC__) || defined(__cplusplus)
extern void show_matrix( LMPNet );
#else
extern void show_matrix();
#endif
        /* Argumente: LMPNet net                                             */
        /* Gibt die Inzidenzmatrix des Netzes 'net' auf dem Bildschirm aus.  */


#endif
