#include <stdlib.h>
#include "neunetze.h"
#include "convertPEP.h"

LMPNet net;

void print_meaning(M_LIST Mlist)
{
    P_LIST plst;
    M_LIST mlst;
    for(mlst=Mlist;mlst;mlst=mlst->next){
	fprintf(stderr,"%d nodes have meaning '%s': ",
		mlst->number,mlst->meaning);
	for(plst=mlst->list;plst;plst=plst->next){
	    fprintf(stderr,"%s ",plst->item->name);
	}
	fprintf(stderr,"\n");
    }
	fprintf(stderr,"\n");
}

int 
main(int argc, char **argv)
{
    CM_storeMeaning = 1;	
    if ((net=read_PEP(argc==1?"tst.ll_net" : argv[1])) == NULL) {
	fprintf(stderr, "ERROR: Can't read net file %s\n", argv[1]);
	return (99);
    };
    
    print_meaning(CM_transMList);
    print_meaning(CM_placeMList);
    
    exit(0);
}
