#ifndef __LP_MISC_H__
#define __LP_MISC_H__

#include <stdio.h>
#include "neunetze.h"
#include "setop.h"
#include "lpkit.h"

extern char *cplex_mip_msg[];
extern char *cplex_msg[];

extern REAL *init_marking;

extern unsigned int max_tokens;

extern FILE *out_f;

#define undef 2
#define A_0 (1.0/max_coeff)
#define A_1 (1.0/max_coeff)
#define A_2 max_coeff

#define ERROR(X) {fprintf(stderr,"%s\n",X);return(1);}

#if defined(__STDC__) || defined (__cplusplus)
int print_sequence (LMPNet net, DSet fire, FILE *out_f);
#else
int print_sequence (net, fire, out_f);
#endif

#if defined(__STDC__) || defined (__cplusplus)
void print_results (lprec *lp);
#else
void print_results (lp);
#endif

#if defined(__STDC__) || defined(__cplusplus)
void print_marking (lprec *lp);
#else
void print_marking (lp);
#endif

#if defined(__STDC__) || defined(__cplusplus)
void print_sub_marking (LMPNet net);
#else
void print_sub_marking (net);
#endif


#endif
