package provide pep_edit 1.0

proc set_binding {what} {

 global anim ref_mode

 switch $what {

	edit {
		bindtags .tedit {Text .tedit . all}
		bind .tedit <Escape> {focus .cmd}
		bind . <Escape> {focus .cmd}
		bind .cmd <Escape> {focus .tedit}
	
		bind .tedit <1> {.textmenu unpost}
		bind .tedit <ButtonRelease-3> {textmenu}
		bind .tedit <Alt_L> {focus .menu}

		bind .tedit <Any-KeyPress> {
			update_cursor
			scan_line
		}

	}
	sim {
		bindtags .tedit {.tedit .}
		bind .tedit <Escape> {enter_edit_mode}
		bind . <Escape> {enter_edit_mode}
		bind .tedit <1> {}
		bind .tedit <2> {}
		bind .tedit <3> {}
		bind .tedit <ButtonRelease-3> {}
		bind .tedit <Any-KeyPress> {}
	}
	anim {
		bind .tedit <Escape> {global anim; set anim 0}
		bind . <Escape> {global anim; set anim 0}
	}
	ref {
		bindtags .tedit {.tedit .}
		bind .tedit <Escape> {enter_edit_mode}
		bind . <Escape> {enter_edit_mode}
		bind .tedit <1> {}
		bind .tedit <2> {}
		bind .tedit <3> {}
		bind .tedit <ButtonRelease-3> {}
		bind .tedit <Any-KeyPress> {}

	}
 }
}

proc textmenu { } {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Wird im Textwidget .tedit die rechte Maustaste gedrueckt,
#            so wird das Textmenue auf dem Bildschirm angezeigt.

   if {[winfo viewable .textmenu]} {
      .textmenu unpost
      focus .tedit
   } else {
      .textmenu post [winfo pointerx .tedit] [winfo pointery .tedit]
   }
}

