############
# Autopath #
############

if {[catch {set env(PEPHOME)}]} {
   set my_auto_path_common "/opt/pep/lib"
   set my_auto_path_pep "/opt/pep/lib/peptool"
   set my_bitmaps_path "/opt/pep/bitmaps/pep_edit"
} else {
  set my_auto_path_common "$env(PEPHOME)/lib"
  set my_auto_path_pep "$env(PEPHOME)/lib/peptool"
  set my_bitmaps_path "$env(PEPHOME)/bitmaps/pep_edit"
}  ;# else, eine Path-Angabe war vorhanden
lappend auto_path $my_auto_path_common
lappend auto_path $my_auto_path_pep

package require pep_edit

##########################################
# Initialisierung der globalen Variablen #
##########################################

if {$argc > 1} {
    set cnnect 1
  } else {
    set cnnect 0
}

set editor(filename) <noname>
set clipboard_load 0
set debug 0
set ref_mode 0

set rc(rcfile) 0
set rc(editor.font) "adobe-helvetica-medium-r-normal--*-120*"
set rc(editor.fontsize) "12"

#set editor(font) [font create [font actual $rc(editor.font)]]
set editor(font) [font create -family {lucidatypewriter} -size $rc(editor.fontsize)]

set editor(keywordfont) [font create -family {lucidatypewriter} -size $rc(editor.fontsize)]
font configure $editor(keywordfont) -weight bold

set editor(remarkfont) [font create -family {arial} -size $rc(editor.fontsize)]
font configure $editor(remarkfont) -slant italic

set rc(bpn2.normal.geometry) "75x25"
set rc(bpn2.expand.geometry) "75x25"
set rc(formula.normal.geometry) "80x06"
set rc(doc.geometry) "61x15"
set rc(sdl.geometry) "75x25"
set rc(boxexpr.geometry) "61x15"

set rc(anim_delay) "500"
set rc(show_ref_in_ll) 1
set rc(show_all_values) 1

# colors for reference mode
set color(ref.active) "steelblue1"
set color(ref.before) "yellow1"
set color(ref.after) "indianred1"
set color(ref.both) "orange1"
set color(ref.normal) "aquamarine1"
set color(ref.variable) "aquamarine1"

if {[catch {set env(PEP_EDITRC)}]} {
   set rcpath $env(HOME)
} else {
   set rcpath $env(PEP_EDITRC)
}

read_options
init_client_com

main_window

