#ifndef CELL_H
#define CELL_H

#include "queue.h"
#include "struct.h"

class Cell
{
  public:
    int v_index;          // Index auf die Knoten-Tabelle
    StructArray StructA;  // Die Alternativen
    int plusinnr;         // Wie oft der Weg von nachfolgenden Prozessen 
                          // benutzt wird
    int changed;          // Fuers finden von Zyklen

    Cell();
    Cell (int _id, StructArray _SA, int _plusinnr, int _changed);
    Cell (int _id, Struct _S, int _plusinnr, int _changed);
    Cell(const Cell& c);
    ~Cell() {}
    Cell& operator =(const Cell& c);
};

typedef Queue<Cell> QueueCell;

#endif
 
