#include "circle.h"

#define CLASS "Circle"

Circle::Circle()
{
  v_index=-1;
}

Circle::Circle(int _id, IntArray _history)
{
  v_index=_id;
  history.Copy(_history);
}

Circle::Circle(const Circle& c)
{
  v_index=c.v_index;
  history.Copy(c.history);
}

Circle& Circle::operator=(const Circle& c)
{
  v_index=c.v_index;
  history.Copy(c.history);
  return *this;
}

