#include <stdlib.h>
#include <string.h>
#include "edge.h"

Edge::Edge()
{
  id=0;
  ref=-1;
  target=-1;
  name=NULL;
}

Edge::~Edge()
{
  if (name)
    free(name);
}

Edge::Edge(const Edge& e)
{
  id=e.id;
  target=e.target;
  ref=e.ref;
  name=strdup(e.name);
}

Edge& Edge::operator=(const Edge& e)
{
  id=e.id;
  ref=e.ref;
  target=e.target;
  name=strdup(e.name);
  return *this;
}

