#ifndef EDGE_H
#define EDGE_H

#include "array.h"

class Edge
{
  public:
    int id;
    int target;
    int ref;
    char *name;
    Edge();
    virtual ~Edge();
    Edge(const Edge& e);
    Edge& operator=(const Edge &e);
    virtual char *GetClassName() { return "Edge"; };
};

typedef Array<class Edge> EdgeArray;

#endif
