#ifndef ERRORS_H
#define ERRORS_H

#define FILE_OPEN_ERR "Could not open file : %s !\n"
#define FIRST_LINE_ERR "Could not read first line !\n"
#define NO_PEP "Invalid file format (PEP) !\n"
#define SECOND_LINE_ERR "Could not read second line !\n"
#define NO_FA "Invalid file format (FiniteAutomation) !\n"
#define THIRD_LINE_ERR "Could not read third line !\n"
#define INVALID_FORMAT "Invalid file format (FORMAT_N) !\n"
#define NO_VAR "Invalid file format (VAR) !\n"
#define INVALID_PRJ "Invalid file format (PROJECT_pepPFA) !\n"
#define EOF_ERR "Unexpected end of file !\n"
#define NFONT_ERR "Could not read node font !\n"
#define EFONT_ERR "Could not read edge font !\n"
#define NODE_ERR "Error in node : %s\n"
#define EDGE_ERR "Error in edge : %s\n"
#define INVALID_CODE "Invalid code : %s\n"
#define INVALID_CIRCLE "Invalid circle found !\n"
#define CIRCLE_ERR "Circle error at exit node !\n"
#define NAMING_ERR "Invalid case in StructNaming !\n"
#define ENDNODE "Error in AnzahlEchteKanten !\n"
#define INV_CASE "Invalid case in Get1EchteKnoten!\n"
#define FA_ERR "Error while reading FA %s !\n"

#endif
