#ifndef STRUCT_H
#define STRUCT_H

#include "array.h"

class Struct
{
  public:
    int v_id;        // Eindeutige Identifizierung
    int count;       // Anzahl der begangenen Alternativen
    int number;      // Anzahl der Alternativen

    Struct();
    Struct(int _v_id, int _count, int _number);
    virtual ~Struct();
    Struct(const Struct &e);
    Struct& operator=(const Struct &e);
    virtual char *GetClassName() { return "Struct"; };
};

typedef Array<class Struct> StructArray;

#endif
