#ifndef VERTEX_H
#define VERTEX_H

#include "array.h"
#include "edge.h"

class Vertex
{
  public:
    int id;
    int typ;
    char *name;
    int compile_id;
    EdgeArray EdgeOut;
    EdgeArray EdgeSame;
    EdgeArray EdgeIn;
    Vertex();
    Vertex(const Vertex& v);
    virtual ~Vertex();
    Vertex& operator=(const Vertex &v);
    virtual char *GetClassName() { return "Vertex"; };
};

typedef Array<class Vertex> VertexArray;

#endif
