#!/bin/sh

SRC="*.prj"
DEST="*.hl_net *_ref"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i;
  $TIME ../pfa2mnet -b -p $i -o `basename $i .prj`.hl_net -r `basename $i .prj`.pfa_hl_ref;
done

#check correctness
for i in ${DEST}; do
  if `diff $i $i.correct >/dev/null`; then
    rm $i;
    echo File $i passed ...;
  else
    echo File $i failed ...;
    echo `pwd`/$i >>$LOG;
  fi
done
