
typedef struct List_element {
	struct List_element *next;
	struct List_element *prev;
	void  *data;
} List_element;

typedef struct {
	List_element *head;
} List_type;

List_type *createList();
void *listFirst(List_type *list, void * data);
void *listLast(List_type *list, void * data);
void *listRemoveFirst(List_type *list);
void *listRemoveLast(List_type *list);
void *listRemove(List_type *list, List_element *link);
void listFree(List_type *list);




