#ifndef __INFO_H__
#define __INFO_H__

#include "function.h"
#include "symtab.h"
#include "intset.h"

typedef struct {
	T_symbol sym;
	char *proc;
	char *name;
	int index;
	int id;
} structdef(info);

extern T_list state_list;
#define alloc_info() (MYmalloc(sizeof(info_instance)))

extern void init_info(void);
extern void delete_info(void);
extern void add_state_info(T_symbol);
extern void add_pid_info(T_symbol,intset);
extern void add_signal_info(T_symbol);
extern void write_info_file(char*);

#endif /* __INFO_H__ */
