#ifndef __SIGNET_H__
#define __SIGNET_H__

#include "symtab.h"
#include "list.h"
#include "intset.h"

extern void sig_init_net();
extern void sig_add_route(T_symbol,T_symbol,T_symbol,T_list);
extern void sig_add_pids(T_symbol,intset);
extern void sig_simnet();
extern void sig_get_relaysets(T_symbol,intset*,intset*,intset*,char);
extern void sig_get_pointsets(T_symbol,intset*,intset*,intset*);
extern T_list sig_find_paths(T_symbol,int);
extern T_symbol sig_get_head(T_list);
extern T_symbol sig_get_tail(T_list);
extern T_list sig_restrict_via(T_list,T_symbol);
extern T_list sig_restrict_goal(T_list,T_symbol);
extern void sig_print_pathlist(T_list);
extern T_list sig_make_unique(T_list);
extern intset sig_get_all_pids();
extern void sig_delete_net();

#endif /* __SIGNET_H__ */
