#ifndef __SORTRANGE_H__
#define __SORTRANGE_H__

#include "function.h"
#include "memlib.h"
#include "symtab.h"
#include "intset.h"
#include "list.h"

extern intset boolset;

extern void check_sort(T_syntype,Integer);
extern void check_subset(intset,intset);
extern T_list intersect_range(T_list,T_list,bool   );
extern intset create_set(T_list);
extern bool range_isfinite(T_list);
extern void init_default_types();
extern void init_implicit_vars();

#define create_range(a,b) ((int)(Cardinal)(a) | ((int)(b) << 16))
#define lower_bound(r) ((Integer)((r) & 0xffff))
#define upper_bound(r) ((r) >> 16)
#define SORT_PID ((intset) 1)

#endif /* __SORTRANGE_H__ */
