
#include "AppVars.h"
#include "Helper.h"

//*******************************************************************************************************
olSDL::ClassAppVars::ClassAppVars() {

	m_str_appl_inst_path = APPL_INST_PATH ;

	m_str_DefaultProjectsDir = m_str_appl_inst_path + "/projects" ;

	m_str_Debug_Dir = m_str_appl_inst_path + "/debug/" ;
	m_str_Dummy_XML_File = m_str_appl_inst_path + "/dtd/dummy.xml" ;

	m_pSystemSpec = NULL ;
} ;
//*******************************************************************************************************
olSDL::SysSpec*  olSDL::ClassAppVars::get_SysSpec() {

	return m_pSystemSpec ;
} ;
//*******************************************************************************************************
string olSDL::ClassAppVars::get_Appl_Inst_Path() {

	return m_str_appl_inst_path ;
} ;
//*******************************************************************************************************
string olSDL::ClassAppVars::get_Dummy_XML_File() {

	return m_str_Dummy_XML_File ;
} ;
//*******************************************************************************************************
string olSDL::ClassAppVars::get_DebugDir() {

	return m_str_Debug_Dir ;
} ;
//*******************************************************************************************************
string olSDL::ClassAppVars::get_DefaultProjectsDir() {

	return m_str_DefaultProjectsDir ;
} ;
//*******************************************************************************************************
void olSDL::ClassAppVars::set_SysSpec(SysSpec* const pSystemSpec) {
	m_pSystemSpec = pSystemSpec ;
} ;
//*******************************************************************************************************


