
#include "ProcedureDia.h"
#include "Helper.h"


//*******************************************************************************************************
olSDL::ClsProcedureDia::ClsProcedureDia(const int Diagram_ID, const string & HeaderPart_Name, const int First_Page_ID, const Symbol * const pReferencingSymbol)
	: Diagram(Diagram_ID, EnumDia::ProcedureDia, HeaderPart_Name, First_Page_ID, pReferencingSymbol) {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("olSDL::ClsProcedureDia::ClsProcedureDia(const int Model_ID)") ;
	#endif

	m_str_FormalParameters = "formal parameters" ;

} ;
//*******************************************************************************************************
olSDL::ClsProcedureDia::~ClsProcedureDia() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("olSDL::ClsProcedureDia::~ClsProcedureDia()") ;
	#endif

} ;
//*******************************************************************************************************
bool olSDL::ClsProcedureDia::is_referenced_Diagram() const {
	return true ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsProcedureDia::get_MoEleType() const {
	return olSDL::ClsMoEleType::ProcedureDia ;
} ;
//*******************************************************************************************************
string olSDL::ClsProcedureDia::get_FormalParameters() const {

	return m_str_FormalParameters ;

} ;
//*******************************************************************************************************
void olSDL::ClsProcedureDia::modify_FormalParameters(string str_FormalParameters) {


	m_str_FormalParameters = str_FormalParameters ;
} ;
//*******************************************************************************************************
