
using namespace std;

#include "SDL_PR_WriterHelper.h"
#include "Converter.h"

#include <algorithm>

//*******************************************************************************************************
const string olSDL::ClsSDL_PR_WriterHelper::LABEL_BASIC_NAME = "grst" ;

//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsSDL_PR_WriterHelper::ClsSDL_PR_WriterHelper() {

	m_LabelMap.clear() ;
	m_LabelCounter = 0 ;
} ;
//*******************************************************************************************************
olSDL::ClsSDL_PR_WriterHelper::~ClsSDL_PR_WriterHelper() {

} ;
//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsSDL_PR_WriterHelper::reset_Helper() {

	m_LabelMap.clear() ;
	m_LabelCounter = 0 ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
bool olSDL::ClsSDL_PR_WriterHelper::set_StateMaSym_written(const int StateMaSymID) {

	if (StateMaSym_written(StateMaSymID)) {
		return false ;
	} ;

	m_LabelMap[StateMaSymID] = (LABEL_BASIC_NAME + Converter::Int_to_String(m_LabelCounter));
	m_LabelCounter++ ;
	return true ;

} ;
//*******************************************************************************************************
bool olSDL::ClsSDL_PR_WriterHelper::StateMaSym_written(const int StateMaSymID) const {

	type_LabelMap::const_iterator iterLabelMap;

	for (iterLabelMap = m_LabelMap.begin(); iterLabelMap != m_LabelMap.end(); iterLabelMap++) {
		if ( (iterLabelMap->first) == StateMaSymID ) {
			return true ;
		} ;
	} ;

	return false ;
	
} ;
//*******************************************************************************************************
string olSDL::ClsSDL_PR_WriterHelper::get_Label(const int StateMaSymID) const {

	type_LabelMap::const_iterator iterLabelMap;

	for (iterLabelMap = m_LabelMap.begin(); iterLabelMap != m_LabelMap.end(); iterLabelMap++) {
		if ( (iterLabelMap->first) == StateMaSymID ) {
			return (iterLabelMap->second) ;
		} ;
	} ;

	return "LabelError";
} ;
//*******************************************************************************************************
