#include "XML_Basic.h"

const string olSDL::ClsXML_Basic::TN_SYSSPEC = "SYSSPEC" ;

const string olSDL::ClsXML_Basic::TN_SYSDIA = "SYSDIA" ;
const string olSDL::ClsXML_Basic::TN_BLKDIA = "BLKDIA" ;
const string olSDL::ClsXML_Basic::TN_PRODIA = "PRODIA" ;
const string olSDL::ClsXML_Basic::TN_PROCEDUREDIA = "PROCEDUREDIA" ;
const string olSDL::ClsXML_Basic::TN_DIANAME = "DIA_NAME" ;
const string olSDL::ClsXML_Basic::TN_FORMAL_PARAMETERS = "FORMAL_PARAMETERS" ;

const string olSDL::ClsXML_Basic::TN_RECSYM_TEXTSYM = "TEXTSYM" ;
const string olSDL::ClsXML_Basic::TN_RECSYM_BLK_INST_REF = "BLK_INST_REF" ;
const string olSDL::ClsXML_Basic::TN_RECSYM_BLK_TYPE_REF = "BLK_TYPE_REF" ;
const string olSDL::ClsXML_Basic::TN_RECSYM_PRO_INST_REF = "PRO_INST_REF" ;
const string olSDL::ClsXML_Basic::TN_RECSYM_PRO_TYPE_REF = "PRO_TYPE_REF" ;
const string olSDL::ClsXML_Basic::TN_RECSYM_PROCEDURE_INST_REF = "PROCEDURE_INST_REF" ;

const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_START = "STATE_MA_SYM_START" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_STATE = "STATE_MA_SYM_STATE" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_OUTPUT = "STATE_MA_SYM_OUTPUT" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_INPUT = "STATE_MA_SYM_INPUT" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_CONDITION = "STATE_MA_SYM_CONDITION" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_STOP = "STATE_MA_SYM_STOP" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_TASK = "STATE_MA_SYM_TASK" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_DECISION = "STATE_MA_SYM_DECISION" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_CREATE_PRO = "STATE_MA_SYM_CREATE_PRO" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_CALL_PROCEDURE = "STATE_MA_SYM_CALL_PROCEDURE" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_PROCEDURE_START_STATE = "STATE_MA_SYM_PROCEDURE_START_STATE" ;
const string olSDL::ClsXML_Basic::TN_STATE_MA_SYM_PROCEDURE_RETURN = "STATE_MA_SYM_PROCEDURE_RETURN" ;


const string olSDL::ClsXML_Basic::TN_NORMAL_FLOWLINE = "NORMAL_FLOWLINE";
const string olSDL::ClsXML_Basic::TN_DECISION_FLOWLINE = "DECISION_FLOWLINE" ;

const string olSDL::ClsXML_Basic::TN_FLOWLINE_SOURCE_ID = "FLOWLINE_SOURCE_ID" ;
const string olSDL::ClsXML_Basic::TN_FLOWLINE_DESTINATION_ID = "FLOWLINE_DESTINATION_ID" ;

const string olSDL::ClsXML_Basic::TN_CHANNEL = "CHANNEL" ;
const string olSDL::ClsXML_Basic::TN_CHANNEL_SOURCE_ID = "CHAN_SOURCE_ID";
const string olSDL::ClsXML_Basic::TN_CHANNEL_DESTINATION_ID = "CHAN_DESTINATION_ID" ;

const string olSDL::ClsXML_Basic::TN_CHANNEL_COMP_NAME = "CHANNEL_COMP_NAME" ;
const string olSDL::ClsXML_Basic::TN_CHANNEL_COMP_SOURCE_SIG = "CHANNEL_COMP_SOURCE_SIG" ;
const string olSDL::ClsXML_Basic::TN_CHANNEL_COMP_SOURCE_CON = "CHANNEL_COMP_SOURCE_CON" ;
const string olSDL::ClsXML_Basic::TN_CHANNEL_COMP_DEST_SIG = "CHANNEL_COMP_DEST_SIG" ;
const string olSDL::ClsXML_Basic::TN_CHANNEL_COMP_DEST_CON = "CHANNEL_COMP_DEST_CON" ;

const string olSDL::ClsXML_Basic::TN_COORDS = "COORDS" ;

const string olSDL::ClsXML_Basic::TN_PAGE = "PAGE" ;
const string olSDL::ClsXML_Basic::TN_PAGEFRAME = "PAGEFRAME" ;

const string olSDL::ClsXML_Basic::TN_PAS = "PAS" ;

const string olSDL::ClsXML_Basic::TN_X_LEFT_UP = "X_LEFT_UP" ;
const string olSDL::ClsXML_Basic::TN_Y_LEFT_UP = "Y_LEFT_UP" ;
const string olSDL::ClsXML_Basic::TN_WIDTH = "WIDTH" ;
const string olSDL::ClsXML_Basic::TN_HEIGHT = "HEIGHT" ;

const string olSDL::ClsXML_Basic::TN_CONTENT = "CONTENT" ;

const string olSDL::ClsXML_Basic::AN_ID = "ID" ;
const string olSDL::ClsXML_Basic::AN_ID_REF = "IDREF" ;
const string olSDL::ClsXML_Basic::AN_PARENT_PAGE_ID = "PARENT_PAGE_ID" ;

const string olSDL::ClsXML_Basic::AN_X_LEFT_UP = "X_LEFT_UP" ;
const string olSDL::ClsXML_Basic::AN_Y_LEFT_UP = "Y_LEFT_UP" ;
const string olSDL::ClsXML_Basic::AN_WIDTH = "WIDTH" ;
const string olSDL::ClsXML_Basic::AN_HEIGHT = "HEIGHT" ;

const string olSDL::ClsXML_Basic::AN_DIRECTION_TYPE = "DIRECTION_TYPE" ;
const string olSDL::ClsXML_Basic::AV_DIRECTION_TYPE_BOTH = "both" ;
const string olSDL::ClsXML_Basic::AV_DIRECTION_TYPE_FROM_SOURCE = "from_source";
const string olSDL::ClsXML_Basic::AV_DIRECTION_TYPE_FROM_DESTINATION = "from_destination" ;

const string olSDL::ClsXML_Basic::AN_DELAY_TYPE = "DELAY_TYPE" ;
const string olSDL::ClsXML_Basic::AV_DELAY_TYPE_DELAY = "delay" ;
const string olSDL::ClsXML_Basic::AV_DELAY_TYPE_NO_DELAY = "no_delay" ;

const string olSDL::ClsXML_Basic::AN_CHANNEL_SOURCE_IS_ENV = "IS_ENV";
const string olSDL::ClsXML_Basic::AV_CHANNEL_SOURCE_IS_ENV_TRUE = "true" ;
const string olSDL::ClsXML_Basic::AV_CHANNEL_SOURCE_IS_ENV_FALSE = "false" ;

const string olSDL::ClsXML_Basic::AN_CHANNEL_DESTINATION_IS_ENV = "IS_ENV" ;
const string olSDL::ClsXML_Basic::AV_CHANNEL_DESTINATION_IS_ENV_TRUE = "true" ;
const string olSDL::ClsXML_Basic::AV_CHANNEL_DESTINATION_IS_ENV_FALSE = "false" ;

//*******************************************************************************************************


//*******************************************************************************************************

