
#ifndef olSDL_CHANNEL_COMP_H
#define olSDL_CHANNEL_COMP_H

#include <string>

#include "BasicTypes.h"


namespace olSDL{

	class ClsChanComp : public ClsRecPaS {

	public:
		enum e_CompType {name, source_sig, dest_sig, source_con, dest_con} ;

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	e_CompType m_CompType ;
	string m_content ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsChanComp(e_CompType CompType, const string content, const ClsRecPaS & PaS) ;

	// Copy

	// Assign

	// Des
	~ClsChanComp() ;

	//============
	// getter
	string get_content( ) const ;

	e_CompType get_CompType() const ;

	//============
	// setter
	void set_content(const string content) ;


	} ; // class

	//=============================================================================
	class ClsChanName : public ClsChanComp {

		public:
		//============
		//Constructor, Copy-Constructor, Assign-Op, ...
		ClsChanName(const string content, const ClsRecPaS & PaS) ;
	} ;
	//=============================================================================
	class ClsChanSourceSigList : public ClsChanComp {

		public:
		//============
		//Constructor, Copy-Constructor, Assign-Op, ...
		ClsChanSourceSigList(const string content, const ClsRecPaS & PaS) ;
	} ;
	//=============================================================================
	class ClsChanDestSigList : public ClsChanComp {

		public:
		//============
		//Constructor, Copy-Constructor, Assign-Op, ...
		ClsChanDestSigList(const string content, const ClsRecPaS & PaS) ;
	} ;
	//=============================================================================
	class ClsChanSourceCon : public ClsChanComp {

		public:
		//============
		//Constructor, Copy-Constructor, Assign-Op, ...
		ClsChanSourceCon(const string content, const ClsRecPaS & PaS) ;
	} ;
	//=============================================================================
	class ClsChanDestCon : public ClsChanComp {

		public:
		//============
		//Constructor, Copy-Constructor, Assign-Op, ...
		ClsChanDestCon(const string content, const ClsRecPaS & PaS) ;
	} ;


} // END: namespace ol_SDL


#endif
