#ifndef olSDL_HELPER
#define olSDL_HELPER

using namespace std;
#include <stdio.h>
#include <string>
#include <list>


namespace olSDL {

	//=============================================================================
	class DebugPrinter {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	static string NameDebugFile ;
	static DebugPrinter *pDebugPrinter ;
	static FILE *pFile ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	private:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	DebugPrinter(string FileName) ; 	// Singleton !!

	public:
	// Des
	~DebugPrinter() ;

	//============
	// getter
	public:
	static void get_Instance(string FileName) ;
	static void free_Instance() ;

	static void print(const string message, const bool withNewline= true) ;
	static void print_iNumber(const int number, const bool withNewline= true) ;
	static void olSDL::DebugPrinter::print_iList(const list<int> & iList) ;

	} ; // class DebugPrinter

} // END: namespace ol_SDL

#endif
