
#ifndef olSDL_PROCESS_DIA_H
#define olSDL_PROCESS_DIA_H

#include "Diagram.h"

namespace olSDL{

	class ClsProcessDia : public Diagram {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsProcessDia(const int Diagram_ID, const string & HeaderPart_Name, const int First_Page_ID, const Symbol * const pReferencingSymbol) ;

	// Des
	~ClsProcessDia() ;

	public:
	//============
	// getter
	bool is_referenced_Diagram() const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	// symbols
	void get_Syms(const EnumSym::Type SymbolType, const int Page_ID, type_ListOf_Poi_to_ConstSym & ResultList,
					ClsMoAccessInfo & Info) const ;

	// symbols
	const Symbol * insert_Symbol(const EnumSym::Type SymbolType, const int Symbol_ID, const int Page_ID,
				       	            const int x_left_up, const int y_left_up, const int width, const int height ,
						    const string content, const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID,
						    ClsMoAccessInfo & Info) ;

	} ; // class ClsProcessDia

} // END: namespace ol_SDL


#endif
