
package provide olSDL_Helper 1

namespace eval olSDL_Helper {
	variable DebugDir [file join . "debug"]
	variable DebugFile [file join $DebugDir "Felder"]
}

###########################################
proc ::olSDL_Helper::printArray {arr_Name} {
	upvar $arr_Name Name

	set MyFile [open $::olSDL_Helper::DebugFile a+]

	foreach element [lsort [array names Name]] {
		puts $MyFile "$element = $Name($element)"
	}
	puts $MyFile "-------------------------------"
	close $MyFile

}
###########################################
proc ::olSDL_Helper::printMessage {str_Message} {
	set MyFile [open $::olSDL_Helper::DebugFile a+]

	puts $MyFile $str_Message

	puts $MyFile "-------------------------------"
	close $MyFile
}
###########################################
proc ::olSDL_Helper::showBindings {obj} {
	set MyFile [open $::olSDL_Helper::DebugFile a+]

	puts $MyFile "-------------------------------"

	set listBinding [bindtags $obj]
	foreach element $listBinding {
		puts $MyFile "BindingTag: $element"
		puts $MyFile "Bindings: [bind $element]"
	}

	puts $MyFile "-------------------------------"
	close $MyFile
}
###########################################
proc ::olSDL_Helper::make_Callback { args } {
	set MyNamespace [uplevel {namespace current}]
	return [list namespace inscope $MyNamespace $args]
}
###########################################

