/*
       Threads. java
 */

import dnx.lr.*;
import dnx.lr.node.*;
import dnx.lr.app.*;
import dnx.lr.field.*;
import dnx.geom.*;
import dnx.awtutil.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.net.MalformedURLException;
import java.io.File;
import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.*;
import java.io.*;
import java.lang.*;
import Browse;
import jcom;

class TranslateThread extends Thread {

   TransformNode tn;
   float dx, dy, dz;
   int maxSteps;
   String id;

   // Constructor
   public TranslateThread (TransformNode tn, float dx, float dy, float dz,
				int maxSteps, String id) {

	this.tn = tn;
	this.dx = dx;
	this.dy = dy;
	this.dz = dz;
	this.maxSteps = maxSteps;
	this.id = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;
	// get current values
        float[] translation = new float[3];
	tn.translation.getValue( translation );
		
        for ( i=1; i<=maxSteps; i++) {
	   translation[0] -= dx;
	   translation[1] -= dy;
	   translation[2] -= dz;

	   tn.translation.setValue(translation[0], translation[1],
                                                translation[2]);
	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}

	// Finish
	jcom.send( "animationReady "+id );
   }
}
