/*****************************************************************************/
/* readlib.h								     */
/*****************************************************************************/
/*				    Stefan Roemer,  06.02.1995 - 06.02.1995  */
/*				    Stefan Schwoon, April 1997		     */
/*****************************************************************************/

#ifndef __READLIB_H__
#define __READLIB_H__

#define ReadCharComment RL_ReadCharComment

/* Some function defs from net_routines */
void ReadNewline( FILE * );
char ReadWhiteSpace( FILE * );
int ReadNumber( FILE * );
char* ReadCmdToken(FILE *file);
char ReadName(FILE *file, char* string, int maxlen);

/*****************************************************************************/
/* Globale Variable: aktuelle Zeilennummer in der Eingabedatei.		     */
/*****************************************************************************/

extern char *NNinput_file;
extern int   NNinput_line;

/*****************************************************************************/
/* Puffer zum Einlesen von Strings. Vergroessert sich automatisch.	     */
/*****************************************************************************/

extern char *sbuf;
extern int  sballoc;

extern char *cbuf,*cc;
extern int  cballoc,cbused;
extern int  commenthack;

extern char errbuf[];
extern void (*PEPerror)(char*); /* Function pointer variable; this is called
                                   whenever an error in a PEP file is discovered
                                   during parsing. Default behaviour is to
                                   display the error given in char* and quit,
                                   but if you want to change that, just redefine
                                   this variable. */
 
#define Error(msg) { sprintf msg; PEPerror(errbuf); }

/*****************************************************************************/
/* Hilfsroutinen zum Einlesen von Netzdateien.				     */
/*****************************************************************************/

extern char ReadCharComment(FILE *file);

#endif

