SRC1="*.ll_net"
SRC2="*.hl_net"
DEST="*.min"

rm -f $DEST

for i in ${SRC1}; do
  echo Checking $i;
  ../simplify $i;
done

for i in *.*ll*.min; do
if (diff -w $i $i.correct); then
  echo File $i passed;
  rm -f $i;
else
  echo File $i failed from ll_net;
fi
done

for i in ${SRC2}; do
  echo Checking $i;
  ../simplify $i;
done

for i in *.*hl*.min; do
if (diff -w $i $i.correct); then
  echo File $i passed;
  rm -f $i;
else
  echo File $i failed from hl_net;
fi
done
