/*****************************************************************************/
/* mtupel.h                                                                  */
/*****************************************************************************/

#ifndef __MTBLOCK_H__
#define __MTBLOCK_H__

#include "memlib.h"
#include "list.h"

/* fuer blockinfo */
#define VARIABLE  1
#define CHANNEL	  2
#define STACK	  3
#define PROCEDURE 4

typedef struct
{
	int ident, type, index, anz, maxdimen, mindimen;
} *t_bi,t_bi_elem;

typedef struct t_defitem_elem
{
	char type;
	char flag;
	int nr;
	int size;
	T_list idset;
	struct t_defitem_elem *proc;

	T_list list1, list2;
	T_list array;
	T_list more;
} *T_defitem, defitem_elem;

#define MT_PlaceBI(mt,num) ((t_bi)(mt)->place[num])

#define alloc_defitem() ((T_defitem)MYmalloc(sizeof(defitem_elem)))

#endif /* __MTBLOCK_H__ */

